function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var SET_QUERY = 'SET_QUERY';
var SET_APPBASE_QUERY = 'SET_APPBASE_QUERY';
var SET_QUERY_OPTIONS = 'SET_QUERY_OPTIONS';
var UPDATE_HITS = 'UPDATE_HITS';
var UPDATE_AGGS = 'UPDATE_AGGS';
var UPDATE_COMPOSITE_AGGS = 'UPDATE_COMPOSITE_AGGS';
var UPDATE_CONFIG = 'UPDATE_CONFIG';
var LOG_QUERY = 'LOG_QUERY';
var LOG_COMBINED_QUERY = 'LOG_COMBINED_QUERY';
var SET_LOADING = 'SET_LOADING';
var SET_ERROR = 'SET_ERROR';
var SET_TIMESTAMP = 'SET_TIMESTAMP';
var SET_HEADERS = 'SET_HEADERS';
var SET_QUERY_LISTENER = 'SET_QUERY_LISTENER';
var SET_SEARCH_ID = 'SET_SEARCH_ID';
var SET_PROMOTED_RESULTS = 'SET_PROMOTED_RESULTS';
var SET_DEFAULT_QUERY = 'SET_DEFAULT_QUERY';
var SET_CUSTOM_QUERY = 'SET_CUSTOM_QUERY';
var SET_CUSTOM_HIGHLIGHT_OPTIONS = 'SET_CUSTOM_HIGHLIGHT_OPTIONS';
var SET_CUSTOM_DATA = 'SET_CUSTOM_DATA';
var SET_APPLIED_SETTINGS = 'SET_APPLIED_SETTINGS';
var SET_SUGGESTIONS_SEARCH_ID = 'SET_SUGGESTIONS_SEARCH_ID';
var SET_RAW_DATA = 'SET_RAW_DATA';
var SET_POPULAR_SUGGESTIONS = 'SET_POPULAR_SUGGESTIONS';
var SET_DEFAULT_POPULAR_SUGGESTIONS = 'SET_DEFAULT_POPULAR_SUGGESTIONS';
var SET_VALUES = 'SET_VALUES';
var SET_GOOGLE_MAP_SCRIPT_LOADING = 'SET_GOOGLE_MAP_SCRIPT_LOADING';
var SET_GOOGLE_MAP_SCRIPT_LOADED = 'SET_GOOGLE_MAP_SCRIPT_LOADED';
var SET_GOOGLE_MAP_SCRIPT_ERROR = 'SET_GOOGLE_MAP_SCRIPT_ERROR';
var SET_AI_RESPONSE = 'SET_AI_RESPONSE';
var SET_AI_RESPONSE_DELAYED = 'SET_AI_RESPONSE_DELAYED';
var REMOVE_AI_RESPONSE = 'REMOVE_AI_RESPONSE';
var SET_AI_RESPONSE_ERROR = 'SET_AI_RESPONSE_ERROR';
var SET_AI_RESPONSE_LOADING = 'SET_AI_RESPONSE_LOADING';

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var dayjs_min = {exports: {}};

(function (module, exports) {
  !function (t, e) {
    module.exports = e() ;
  }(commonjsGlobal, function () {

    var t = 1e3,
      e = 6e4,
      n = 36e5,
      r = "millisecond",
      i = "second",
      s = "minute",
      u = "hour",
      a = "day",
      o = "week",
      c = "month",
      f = "quarter",
      h = "year",
      d = "date",
      l = "Invalid Date",
      $ = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,
      y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,
      M = {
        name: "en",
        weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
        months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
        ordinal: function ordinal(t) {
          var e = ["th", "st", "nd", "rd"],
            n = t % 100;
          return "[" + t + (e[(n - 20) % 10] || e[n] || e[0]) + "]";
        }
      },
      m = function m(t, e, n) {
        var r = String(t);
        return !r || r.length >= e ? t : "" + Array(e + 1 - r.length).join(n) + t;
      },
      v = {
        s: m,
        z: function z(t) {
          var e = -t.utcOffset(),
            n = Math.abs(e),
            r = Math.floor(n / 60),
            i = n % 60;
          return (e <= 0 ? "+" : "-") + m(r, 2, "0") + ":" + m(i, 2, "0");
        },
        m: function t(e, n) {
          if (e.date() < n.date()) return -t(n, e);
          var r = 12 * (n.year() - e.year()) + (n.month() - e.month()),
            i = e.clone().add(r, c),
            s = n - i < 0,
            u = e.clone().add(r + (s ? -1 : 1), c);
          return +(-(r + (n - i) / (s ? i - u : u - i)) || 0);
        },
        a: function a(t) {
          return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
        },
        p: function p(t) {
          return {
            M: c,
            y: h,
            w: o,
            d: a,
            D: d,
            h: u,
            m: s,
            s: i,
            ms: r,
            Q: f
          }[t] || String(t || "").toLowerCase().replace(/s$/, "");
        },
        u: function u(t) {
          return void 0 === t;
        }
      },
      g = "en",
      D = {};
    D[g] = M;
    var p = "$isDayjsObject",
      S = function S(t) {
        return t instanceof _ || !(!t || !t[p]);
      },
      w = function t(e, n, r) {
        var i;
        if (!e) return g;
        if ("string" == typeof e) {
          var s = e.toLowerCase();
          D[s] && (i = s), n && (D[s] = n, i = s);
          var u = e.split("-");
          if (!i && u.length > 1) return t(u[0]);
        } else {
          var a = e.name;
          D[a] = e, i = a;
        }
        return !r && i && (g = i), i || !r && g;
      },
      O = function O(t, e) {
        if (S(t)) return t.clone();
        var n = "object" == _typeof(e) ? e : {};
        return n.date = t, n.args = arguments, new _(n);
      },
      b = v;
    b.l = w, b.i = S, b.w = function (t, e) {
      return O(t, {
        locale: e.$L,
        utc: e.$u,
        x: e.$x,
        $offset: e.$offset
      });
    };
    var _ = function () {
        function M(t) {
          this.$L = w(t.locale, null, !0), this.parse(t), this.$x = this.$x || t.x || {}, this[p] = !0;
        }
        var m = M.prototype;
        return m.parse = function (t) {
          this.$d = function (t) {
            var e = t.date,
              n = t.utc;
            if (null === e) return new Date(NaN);
            if (b.u(e)) return new Date();
            if (e instanceof Date) return new Date(e);
            if ("string" == typeof e && !/Z$/i.test(e)) {
              var r = e.match($);
              if (r) {
                var i = r[2] - 1 || 0,
                  s = (r[7] || "0").substring(0, 3);
                return n ? new Date(Date.UTC(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s)) : new Date(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s);
              }
            }
            return new Date(e);
          }(t), this.init();
        }, m.init = function () {
          var t = this.$d;
          this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
        }, m.$utils = function () {
          return b;
        }, m.isValid = function () {
          return !(this.$d.toString() === l);
        }, m.isSame = function (t, e) {
          var n = O(t);
          return this.startOf(e) <= n && n <= this.endOf(e);
        }, m.isAfter = function (t, e) {
          return O(t) < this.startOf(e);
        }, m.isBefore = function (t, e) {
          return this.endOf(e) < O(t);
        }, m.$g = function (t, e, n) {
          return b.u(t) ? this[e] : this.set(n, t);
        }, m.unix = function () {
          return Math.floor(this.valueOf() / 1e3);
        }, m.valueOf = function () {
          return this.$d.getTime();
        }, m.startOf = function (t, e) {
          var n = this,
            r = !!b.u(e) || e,
            f = b.p(t),
            l = function l(t, e) {
              var i = b.w(n.$u ? Date.UTC(n.$y, e, t) : new Date(n.$y, e, t), n);
              return r ? i : i.endOf(a);
            },
            $ = function $(t, e) {
              return b.w(n.toDate()[t].apply(n.toDate("s"), (r ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e)), n);
            },
            y = this.$W,
            M = this.$M,
            m = this.$D,
            v = "set" + (this.$u ? "UTC" : "");
          switch (f) {
            case h:
              return r ? l(1, 0) : l(31, 11);
            case c:
              return r ? l(1, M) : l(0, M + 1);
            case o:
              var g = this.$locale().weekStart || 0,
                D = (y < g ? y + 7 : y) - g;
              return l(r ? m - D : m + (6 - D), M);
            case a:
            case d:
              return $(v + "Hours", 0);
            case u:
              return $(v + "Minutes", 1);
            case s:
              return $(v + "Seconds", 2);
            case i:
              return $(v + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, m.endOf = function (t) {
          return this.startOf(t, !1);
        }, m.$set = function (t, e) {
          var n,
            o = b.p(t),
            f = "set" + (this.$u ? "UTC" : ""),
            l = (n = {}, n[a] = f + "Date", n[d] = f + "Date", n[c] = f + "Month", n[h] = f + "FullYear", n[u] = f + "Hours", n[s] = f + "Minutes", n[i] = f + "Seconds", n[r] = f + "Milliseconds", n)[o],
            $ = o === a ? this.$D + (e - this.$W) : e;
          if (o === c || o === h) {
            var y = this.clone().set(d, 1);
            y.$d[l]($), y.init(), this.$d = y.set(d, Math.min(this.$D, y.daysInMonth())).$d;
          } else l && this.$d[l]($);
          return this.init(), this;
        }, m.set = function (t, e) {
          return this.clone().$set(t, e);
        }, m.get = function (t) {
          return this[b.p(t)]();
        }, m.add = function (r, f) {
          var d,
            l = this;
          r = Number(r);
          var $ = b.p(f),
            y = function y(t) {
              var e = O(l);
              return b.w(e.date(e.date() + Math.round(t * r)), l);
            };
          if ($ === c) return this.set(c, this.$M + r);
          if ($ === h) return this.set(h, this.$y + r);
          if ($ === a) return y(1);
          if ($ === o) return y(7);
          var M = (d = {}, d[s] = e, d[u] = n, d[i] = t, d)[$] || 1,
            m = this.$d.getTime() + r * M;
          return b.w(m, this);
        }, m.subtract = function (t, e) {
          return this.add(-1 * t, e);
        }, m.format = function (t) {
          var e = this,
            n = this.$locale();
          if (!this.isValid()) return n.invalidDate || l;
          var r = t || "YYYY-MM-DDTHH:mm:ssZ",
            i = b.z(this),
            s = this.$H,
            u = this.$m,
            a = this.$M,
            o = n.weekdays,
            c = n.months,
            f = n.meridiem,
            h = function h(t, n, i, s) {
              return t && (t[n] || t(e, r)) || i[n].slice(0, s);
            },
            d = function d(t) {
              return b.s(s % 12 || 12, t, "0");
            },
            $ = f || function (t, e, n) {
              var r = t < 12 ? "AM" : "PM";
              return n ? r.toLowerCase() : r;
            };
          return r.replace(y, function (t, r) {
            return r || function (t) {
              switch (t) {
                case "YY":
                  return String(e.$y).slice(-2);
                case "YYYY":
                  return b.s(e.$y, 4, "0");
                case "M":
                  return a + 1;
                case "MM":
                  return b.s(a + 1, 2, "0");
                case "MMM":
                  return h(n.monthsShort, a, c, 3);
                case "MMMM":
                  return h(c, a);
                case "D":
                  return e.$D;
                case "DD":
                  return b.s(e.$D, 2, "0");
                case "d":
                  return String(e.$W);
                case "dd":
                  return h(n.weekdaysMin, e.$W, o, 2);
                case "ddd":
                  return h(n.weekdaysShort, e.$W, o, 3);
                case "dddd":
                  return o[e.$W];
                case "H":
                  return String(s);
                case "HH":
                  return b.s(s, 2, "0");
                case "h":
                  return d(1);
                case "hh":
                  return d(2);
                case "a":
                  return $(s, u, !0);
                case "A":
                  return $(s, u, !1);
                case "m":
                  return String(u);
                case "mm":
                  return b.s(u, 2, "0");
                case "s":
                  return String(e.$s);
                case "ss":
                  return b.s(e.$s, 2, "0");
                case "SSS":
                  return b.s(e.$ms, 3, "0");
                case "Z":
                  return i;
              }
              return null;
            }(t) || i.replace(":", "");
          });
        }, m.utcOffset = function () {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, m.diff = function (r, d, l) {
          var $,
            y = this,
            M = b.p(d),
            m = O(r),
            v = (m.utcOffset() - this.utcOffset()) * e,
            g = this - m,
            D = function D() {
              return b.m(y, m);
            };
          switch (M) {
            case h:
              $ = D() / 12;
              break;
            case c:
              $ = D();
              break;
            case f:
              $ = D() / 3;
              break;
            case o:
              $ = (g - v) / 6048e5;
              break;
            case a:
              $ = (g - v) / 864e5;
              break;
            case u:
              $ = g / n;
              break;
            case s:
              $ = g / e;
              break;
            case i:
              $ = g / t;
              break;
            default:
              $ = g;
          }
          return l ? $ : b.a($);
        }, m.daysInMonth = function () {
          return this.endOf(c).$D;
        }, m.$locale = function () {
          return D[this.$L];
        }, m.locale = function (t, e) {
          if (!t) return this.$L;
          var n = this.clone(),
            r = w(t, e, !0);
          return r && (n.$L = r), n;
        }, m.clone = function () {
          return b.w(this.$d, this);
        }, m.toDate = function () {
          return new Date(this.valueOf());
        }, m.toJSON = function () {
          return this.isValid() ? this.toISOString() : null;
        }, m.toISOString = function () {
          return this.$d.toISOString();
        }, m.toString = function () {
          return this.$d.toUTCString();
        }, M;
      }(),
      k = _.prototype;
    return O.prototype = k, [["$ms", r], ["$s", i], ["$m", s], ["$H", u], ["$W", a], ["$M", c], ["$y", h], ["$D", d]].forEach(function (t) {
      k[t[1]] = function (e) {
        return this.$g(e, t[0], t[1]);
      };
    }), O.extend = function (t, e) {
      return t.$i || (t(e, _, O), t.$i = !0), O;
    }, O.locale = w, O.isDayjs = S, O.unix = function (t) {
      return O(1e3 * t);
    }, O.en = D[g], O.Ls = D, O.p = {}, O;
  });
})(dayjs_min);
var dayjs_minExports = dayjs_min.exports;
var dayjs = /*@__PURE__*/getDefaultExportFromCjs(dayjs_minExports);

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};
var queryTypes = {
  search: 'search',
  term: 'term',
  range: 'range',
  geo: 'geo',
  suggestion: 'suggestion'
};

var dateFormats = {
  date: 'YYYY-MM-DD',
  basic_date: 'YYYYMMDD',
  basic_date_time: 'YYYYMMDD[T]HHmmss.SSSZ',
  basic_date_time_no_millis: 'YYYYMMDD[T]HHmmssZ',
  date_time_no_millis: 'YYYY-MM-DD[T]HH:mm:ssZ',
  basic_time: 'HHmmss.SSSZ',
  basic_time_no_millis: 'HHmmssZ',
  epoch_millis: 'epoch_millis',
  epoch_second: 'epoch_second'
};

var _componentTypeToDefau;
function formatDate(date, props) {
  if (props.parseDate) {
    // We would be passing an instance of dayjs instead of xdate below. Users need to know.
    return props.parseDate(date, props);
  }
  switch (props.queryFormat) {
    case 'epoch_millis':
      return date.valueOf();
    case 'epoch_second':
      return Math.floor(date.valueOf() / 1000);
    default:
      {
        if (dateFormats[props.queryFormat]) {
          return date.format(dateFormats[props.queryFormat]);
        }
        return date.valueOf();
      }
  }
}
(_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));

var _componentToTypeMap;
function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
(_componentToTypeMap = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.reactiveList, queryTypes.search), componentTypes.dataSearch, queryTypes.search), componentTypes.categorySearch, queryTypes.search), componentTypes.searchBox, queryTypes.suggestion), componentTypes.AIAnswer, queryTypes.search), componentTypes.singleList, queryTypes.term), componentTypes.multiList, queryTypes.term), componentTypes.singleDataList, queryTypes.term), componentTypes.singleDropdownList, queryTypes.term), componentTypes.multiDataList, queryTypes.term), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownList, queryTypes.term), componentTypes.tagCloud, queryTypes.term), componentTypes.toggleButton, queryTypes.term), componentTypes.reactiveChart, queryTypes.term), componentTypes.treeList, queryTypes.term), componentTypes.numberBox, queryTypes.term), componentTypes.datePicker, queryTypes.range), componentTypes.dateRange, queryTypes.range), componentTypes.dynamicRangeSlider, queryTypes.range), componentTypes.singleDropdownRange, queryTypes.range), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownRange, queryTypes.range), componentTypes.singleRange, queryTypes.range), componentTypes.multiRange, queryTypes.range), componentTypes.rangeSlider, queryTypes.range), componentTypes.ratingsFilter, queryTypes.range), componentTypes.rangeInput, queryTypes.range), componentTypes.geoDistanceDropdown, queryTypes.geo), componentTypes.geoDistanceSlider, queryTypes.geo), componentTypes.reactiveMap, queryTypes.geo));
var transformValueToComponentStateFormat = function transformValueToComponentStateFormat(value, componentProps) {
  var componentType = componentProps.componentType,
    data = componentProps.data,
    queryFormat = componentProps.queryFormat;
  var transformedValue = value;
  var meta = {};
  if (value) {
    switch (componentType) {
      case componentTypes.singleDataList:
      case componentTypes.tabDataList:
        transformedValue = '';
        if (Array.isArray(value) && typeof value[0] === 'string') {
          transformedValue = value[0];
        } else if (_typeof(value) === 'object' && value.label) {
          transformedValue = value.label;
        } else {
          transformedValue = value;
        }
        break;
      case componentTypes.multiDataList:
        transformedValue = [];
        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && (valObj.label || valObj.value)) {
              transformedValue.push(valObj.label || valObj.value);
            } else if (typeof valObj === 'string') {
              transformedValue.push(valObj);
            }
          });
        }
        break;
      case componentTypes.toggleButton:
        transformedValue = []; // array of objects

        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && valObj.label && valObj.value) {
              transformedValue.push(valObj);
            } else if (typeof valObj === 'string') {
              var findDataObj = data.find(function (item) {
                return item.label.trim() === valObj.trim() || item.value.trim() === valObj.trim();
              });
              transformedValue.push(findDataObj);
            }
          });
        } else if (_typeof(value) === 'object' && value.label && value.value) {
          transformedValue = value.value;
        } else if (typeof value === 'string') {
          var findDataObj = data.find(function (item) {
            return item.label.trim() === value.trim() || item.value.trim() === value.trim();
          });
          transformedValue = findDataObj.value;
        }
        break;
      case componentTypes.singleRange:
      case componentTypes.singleDropdownRange:
        transformedValue = {};
        if (!Array.isArray(value) && _typeof(value) === 'object') {
          transformedValue = _objectSpread$1({}, value);
        } else if (typeof value === 'string') {
          var _findDataObj = data.find(function (item) {
            return item.label.trim() === value.trim();
          });
          transformedValue = _objectSpread$1({}, _findDataObj);
        }
        break;
      case componentTypes.multiDropdownRange:
      case componentTypes.multiRange:
        transformedValue = []; // array of objects

        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && typeof valObj.start === 'number' && typeof valObj.end === 'number') {
              var _findDataObj2 = _objectSpread$1({}, valObj);
              if (!_findDataObj2.label) {
                _findDataObj2 = data.find(function (item) {
                  return item.start === valObj.start && item.end === valObj.end;
                });
              }
              transformedValue.push(_findDataObj2);
            } else if (typeof valObj === 'string') {
              var _findDataObj3 = data.find(function (item) {
                return item.label.trim() === valObj.trim();
              });
              transformedValue.push(_findDataObj3);
            }
          });
        } else if (typeof value === 'string') {
          var _findDataObj4 = data.find(function (item) {
            return item.label.trim() === value.trim();
          });
          transformedValue.push(_findDataObj4);
        }
        break;
      case componentTypes.rangeSlider:
      case componentTypes.ratingsFilter:
      case componentTypes.dynamicRangeSlider:
      case componentTypes.reactiveChart:
        transformedValue = [];
        if (queryFormat) {
          if (Array.isArray(value)) {
            transformedValue = value.map(function (item) {
              return formatDate(dayjs(item), componentProps);
            });
          } else if (_typeof(value) === 'object') {
            transformedValue = [formatDate(dayjs(value.start), componentProps), formatDate(dayjs(value.end), componentProps)];
          }
        } else if (Array.isArray(value)) {
          transformedValue = _toConsumableArray(value);
        } else if (_typeof(value) === 'object') {
          transformedValue = [value.start, value.end];
        } else {
          transformedValue = value;
        }
        break;
      case componentTypes.numberBox:
        transformedValue = [];
        if (!Array.isArray(value) && _typeof(value) === 'object') {
          transformedValue = value.start;
        } else if (typeof value === 'number') {
          transformedValue = value;
        }
        break;
      case componentTypes.datePicker:
        transformedValue = '';
        if (_typeof(value) !== 'object') {
          transformedValue = dayjs(value).format('YYYY-MM-DD');
        } else if (value.end) {
          transformedValue = dayjs(value.end).format('YYYY-MM-DD');
        } else if (value.start) {
          transformedValue = dayjs(value.start).add(24, 'hour').format('YYYY-MM-DD');
        }
        break;
      case componentTypes.dateRange:
        transformedValue = []; // array of strings
        if (Array.isArray(value)) {
          transformedValue = value.map(function (t) {
            return dayjs(t).format('YYYY-MM-DD');
          });
        } else if (_typeof(value) === 'object') {
          transformedValue = [dayjs(value.start).format('YYYY-MM-DD'), dayjs(value.end).format('YYYY-MM-DD')];
        }
        break;
      case componentTypes.categorySearch:
        transformedValue = '';
        if (_typeof(value) === 'object') {
          transformedValue = value.value;
          if (value.category !== undefined) {
            meta.category = value.category;
          }
        } else if (typeof value === 'string') {
          transformedValue = value;
        }
        break;
    }
  }
  return {
    value: transformedValue,
    meta: meta
  };
};

function updateAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateCompositeAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_COMPOSITE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateHits(component, hits, time, hidden) {
  var append = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return {
    type: UPDATE_HITS,
    component: component,
    hits: hits.hits,
    // make compatible with es7
    total: _typeof(hits.total) === 'object' ? hits.total.value : hits.total,
    hidden: hidden,
    time: time,
    append: append
  };
}

function updateStoreConfig(payload) {
  return function (dispatch) {
    dispatch({
      type: UPDATE_CONFIG,
      config: payload
    });
  };
}

function setValues(componentsValues) {
  return function (dispatch) {
    dispatch(updateStoreConfig({
      queryLockConfig: {
        initialTimestamp: new Date().getTime(),
        lockTime: 300
      }
    }));
    dispatch({
      type: SET_VALUES,
      componentsValues: componentsValues
    });
  };
}

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function setRawData(component, response) {
  return {
    type: SET_RAW_DATA,
    component: component,
    response: response
  };
}
function setLoading(component, isLoading) {
  return {
    type: SET_LOADING,
    component: component,
    isLoading: isLoading
  };
}
function setError(component, error) {
  return {
    type: SET_ERROR,
    component: component,
    error: error
  };
}
function setTimestamp(component, timestamp) {
  return {
    type: SET_TIMESTAMP,
    component: component,
    timestamp: timestamp
  };
}
function setSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SEARCH_ID,
    searchId: searchId
  };
}
function setSuggestionsSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SUGGESTIONS_SEARCH_ID,
    searchId: searchId
  };
}
function setQuery(component, query) {
  return {
    type: SET_QUERY,
    component: component,
    query: query
  };
}
function setCustomQuery(component, query) {
  return {
    type: SET_CUSTOM_QUERY,
    component: component,
    query: query
  };
}
function setDefaultQuery(component, query) {
  return {
    type: SET_DEFAULT_QUERY,
    component: component,
    query: query
  };
}
function setCustomHighlightOptions(component, data) {
  return {
    type: SET_CUSTOM_HIGHLIGHT_OPTIONS,
    component: component,
    data: data
  };
}
function updateQueryOptions(component, options) {
  return {
    type: SET_QUERY_OPTIONS,
    component: component,
    options: options
  };
}

// gatekeeping for normal queries
function logQuery(component, query) {
  return {
    type: LOG_QUERY,
    component: component,
    query: query
  };
}

// gatekeeping for queries combined with map queries
function logCombinedQuery(component, query) {
  return {
    type: LOG_COMBINED_QUERY,
    component: component,
    query: query
  };
}
function setHeaders(headers) {
  return {
    type: SET_HEADERS,
    headers: headers
  };
}
function setPromotedResults() {
  var results = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_PROMOTED_RESULTS,
    results: results,
    component: component
  };
}
function setPopularSuggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_POPULAR_SUGGESTIONS,
    suggestions: suggestions,
    component: component
  };
}
function setDefaultPopularSuggestions() {
  var suggestions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_DEFAULT_POPULAR_SUGGESTIONS,
    suggestions: suggestions,
    component: component
  };
}
function setCustomData() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_CUSTOM_DATA,
    data: data,
    component: component
  };
}
function setAppliedSettings() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_APPLIED_SETTINGS,
    data: data,
    component: component
  };
}
function setQueryListener(component, onQueryChange, onError) {
  return {
    type: SET_QUERY_LISTENER,
    component: component,
    onQueryChange: onQueryChange,
    onError: onError
  };
}
function setGoogleMapScriptLoading(bool) {
  return {
    type: SET_GOOGLE_MAP_SCRIPT_LOADING,
    loading: bool
  };
}
function setGoogleMapScriptLoaded(bool) {
  return {
    type: SET_GOOGLE_MAP_SCRIPT_LOADED,
    loaded: bool
  };
}
function setGoogleMapScriptError(error) {
  return {
    type: SET_GOOGLE_MAP_SCRIPT_ERROR,
    error: error
  };
}
function resetStoreForComponent(componentId) {
  return function (dispatch) {
    dispatch(setRawData(componentId, null));
    dispatch(setCustomData(null, componentId));
    dispatch(setPromotedResults([], componentId));
    dispatch(setPopularSuggestions([], componentId));
    dispatch(setDefaultPopularSuggestions([], componentId));
    dispatch(updateAggs(componentId, null));
    dispatch(updateCompositeAggs(componentId, {}));
    dispatch(updateHits(componentId, {
      hits: [],
      total: 0
    }, 0));
  };
}
function setLastUsedAppbaseQuery(query) {
  return {
    type: SET_APPBASE_QUERY,
    query: query
  };
}
function setSearchState() {
  var componentsValueAndTypeMap = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (dispatch) {
    var componentValues = {};
    Object.keys(componentsValueAndTypeMap).forEach(function (componentId) {
      var _componentsValueAndTy = componentsValueAndTypeMap[componentId],
        value = _componentsValueAndTy.value,
        componentProps = _componentsValueAndTy.componentProps;
      var _transformValueToComp = transformValueToComponentStateFormat(value, componentProps),
        transformedValue = _transformValueToComp.value,
        _transformValueToComp2 = _transformValueToComp.meta,
        meta = _transformValueToComp2 === void 0 ? {} : _transformValueToComp2;
      componentValues[componentId] = _objectSpread({
        value: transformedValue
      }, meta);
    });
    dispatch(setValues(componentValues));
  };
}
function setAIResponse(component, payload) {
  return {
    type: SET_AI_RESPONSE,
    component: component,
    payload: payload
  };
}
function setAIResponseDelayed(component, payload) {
  return {
    type: SET_AI_RESPONSE_DELAYED,
    component: component,
    payload: payload
  };
}
function removeAIResponse(component) {
  return {
    type: REMOVE_AI_RESPONSE,
    component: component
  };
}
function setAIResponseError(component, error) {
  var meta = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return {
    type: SET_AI_RESPONSE_ERROR,
    component: component,
    error: error,
    meta: meta
  };
}
function setAIResponseLoading(component, isLoading) {
  return {
    type: SET_AI_RESPONSE_LOADING,
    component: component,
    isLoading: isLoading
  };
}

export { logCombinedQuery, logQuery, removeAIResponse, resetStoreForComponent, setAIResponse, setAIResponseDelayed, setAIResponseError, setAIResponseLoading, setAppliedSettings, setCustomData, setCustomHighlightOptions, setCustomQuery, setDefaultPopularSuggestions, setDefaultQuery, setError, setGoogleMapScriptError, setGoogleMapScriptLoaded, setGoogleMapScriptLoading, setHeaders, setLastUsedAppbaseQuery, setLoading, setPopularSuggestions, setPromotedResults, setQuery, setQueryListener, setRawData, setSearchId, setSearchState, setSuggestionsSearchId, setTimestamp, updateQueryOptions };
