function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var SET_APPBASE_QUERY = 'SET_APPBASE_QUERY';
var UPDATE_HITS = 'UPDATE_HITS';
var UPDATE_AGGS = 'UPDATE_AGGS';
var UPDATE_COMPOSITE_AGGS = 'UPDATE_COMPOSITE_AGGS';
var UPDATE_CONFIG = 'UPDATE_CONFIG';
var SET_LOADING = 'SET_LOADING';
var SET_ERROR = 'SET_ERROR';
var SET_TIMESTAMP = 'SET_TIMESTAMP';
var SET_SEARCH_ID = 'SET_SEARCH_ID';
var SET_PROMOTED_RESULTS = 'SET_PROMOTED_RESULTS';
var SET_CUSTOM_DATA = 'SET_CUSTOM_DATA';
var SET_APPLIED_SETTINGS = 'SET_APPLIED_SETTINGS';
var SET_SUGGESTIONS_SEARCH_ID = 'SET_SUGGESTIONS_SEARCH_ID';
var SET_RAW_DATA = 'SET_RAW_DATA';
var SET_AI_RESPONSE = 'SET_AI_RESPONSE';
var SET_AI_RESPONSE_DELAYED = 'SET_AI_RESPONSE_DELAYED';
var SET_AI_RESPONSE_ERROR = 'SET_AI_RESPONSE_ERROR';
var SET_AI_RESPONSE_LOADING = 'SET_AI_RESPONSE_LOADING';

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

var dayjs_min = {exports: {}};

(function (module, exports) {
  !function (t, e) {
    module.exports = e() ;
  }(commonjsGlobal, function () {

    var t = 1e3,
      e = 6e4,
      n = 36e5,
      r = "millisecond",
      i = "second",
      s = "minute",
      u = "hour",
      a = "day",
      o = "week",
      c = "month",
      f = "quarter",
      h = "year",
      d = "date",
      l = "Invalid Date",
      $ = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,
      y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,
      M = {
        name: "en",
        weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
        months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
        ordinal: function ordinal(t) {
          var e = ["th", "st", "nd", "rd"],
            n = t % 100;
          return "[" + t + (e[(n - 20) % 10] || e[n] || e[0]) + "]";
        }
      },
      m = function m(t, e, n) {
        var r = String(t);
        return !r || r.length >= e ? t : "" + Array(e + 1 - r.length).join(n) + t;
      },
      v = {
        s: m,
        z: function z(t) {
          var e = -t.utcOffset(),
            n = Math.abs(e),
            r = Math.floor(n / 60),
            i = n % 60;
          return (e <= 0 ? "+" : "-") + m(r, 2, "0") + ":" + m(i, 2, "0");
        },
        m: function t(e, n) {
          if (e.date() < n.date()) return -t(n, e);
          var r = 12 * (n.year() - e.year()) + (n.month() - e.month()),
            i = e.clone().add(r, c),
            s = n - i < 0,
            u = e.clone().add(r + (s ? -1 : 1), c);
          return +(-(r + (n - i) / (s ? i - u : u - i)) || 0);
        },
        a: function a(t) {
          return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
        },
        p: function p(t) {
          return {
            M: c,
            y: h,
            w: o,
            d: a,
            D: d,
            h: u,
            m: s,
            s: i,
            ms: r,
            Q: f
          }[t] || String(t || "").toLowerCase().replace(/s$/, "");
        },
        u: function u(t) {
          return void 0 === t;
        }
      },
      g = "en",
      D = {};
    D[g] = M;
    var p = "$isDayjsObject",
      S = function S(t) {
        return t instanceof _ || !(!t || !t[p]);
      },
      w = function t(e, n, r) {
        var i;
        if (!e) return g;
        if ("string" == typeof e) {
          var s = e.toLowerCase();
          D[s] && (i = s), n && (D[s] = n, i = s);
          var u = e.split("-");
          if (!i && u.length > 1) return t(u[0]);
        } else {
          var a = e.name;
          D[a] = e, i = a;
        }
        return !r && i && (g = i), i || !r && g;
      },
      O = function O(t, e) {
        if (S(t)) return t.clone();
        var n = "object" == _typeof(e) ? e : {};
        return n.date = t, n.args = arguments, new _(n);
      },
      b = v;
    b.l = w, b.i = S, b.w = function (t, e) {
      return O(t, {
        locale: e.$L,
        utc: e.$u,
        x: e.$x,
        $offset: e.$offset
      });
    };
    var _ = function () {
        function M(t) {
          this.$L = w(t.locale, null, !0), this.parse(t), this.$x = this.$x || t.x || {}, this[p] = !0;
        }
        var m = M.prototype;
        return m.parse = function (t) {
          this.$d = function (t) {
            var e = t.date,
              n = t.utc;
            if (null === e) return new Date(NaN);
            if (b.u(e)) return new Date();
            if (e instanceof Date) return new Date(e);
            if ("string" == typeof e && !/Z$/i.test(e)) {
              var r = e.match($);
              if (r) {
                var i = r[2] - 1 || 0,
                  s = (r[7] || "0").substring(0, 3);
                return n ? new Date(Date.UTC(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s)) : new Date(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s);
              }
            }
            return new Date(e);
          }(t), this.init();
        }, m.init = function () {
          var t = this.$d;
          this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
        }, m.$utils = function () {
          return b;
        }, m.isValid = function () {
          return !(this.$d.toString() === l);
        }, m.isSame = function (t, e) {
          var n = O(t);
          return this.startOf(e) <= n && n <= this.endOf(e);
        }, m.isAfter = function (t, e) {
          return O(t) < this.startOf(e);
        }, m.isBefore = function (t, e) {
          return this.endOf(e) < O(t);
        }, m.$g = function (t, e, n) {
          return b.u(t) ? this[e] : this.set(n, t);
        }, m.unix = function () {
          return Math.floor(this.valueOf() / 1e3);
        }, m.valueOf = function () {
          return this.$d.getTime();
        }, m.startOf = function (t, e) {
          var n = this,
            r = !!b.u(e) || e,
            f = b.p(t),
            l = function l(t, e) {
              var i = b.w(n.$u ? Date.UTC(n.$y, e, t) : new Date(n.$y, e, t), n);
              return r ? i : i.endOf(a);
            },
            $ = function $(t, e) {
              return b.w(n.toDate()[t].apply(n.toDate("s"), (r ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e)), n);
            },
            y = this.$W,
            M = this.$M,
            m = this.$D,
            v = "set" + (this.$u ? "UTC" : "");
          switch (f) {
            case h:
              return r ? l(1, 0) : l(31, 11);
            case c:
              return r ? l(1, M) : l(0, M + 1);
            case o:
              var g = this.$locale().weekStart || 0,
                D = (y < g ? y + 7 : y) - g;
              return l(r ? m - D : m + (6 - D), M);
            case a:
            case d:
              return $(v + "Hours", 0);
            case u:
              return $(v + "Minutes", 1);
            case s:
              return $(v + "Seconds", 2);
            case i:
              return $(v + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, m.endOf = function (t) {
          return this.startOf(t, !1);
        }, m.$set = function (t, e) {
          var n,
            o = b.p(t),
            f = "set" + (this.$u ? "UTC" : ""),
            l = (n = {}, n[a] = f + "Date", n[d] = f + "Date", n[c] = f + "Month", n[h] = f + "FullYear", n[u] = f + "Hours", n[s] = f + "Minutes", n[i] = f + "Seconds", n[r] = f + "Milliseconds", n)[o],
            $ = o === a ? this.$D + (e - this.$W) : e;
          if (o === c || o === h) {
            var y = this.clone().set(d, 1);
            y.$d[l]($), y.init(), this.$d = y.set(d, Math.min(this.$D, y.daysInMonth())).$d;
          } else l && this.$d[l]($);
          return this.init(), this;
        }, m.set = function (t, e) {
          return this.clone().$set(t, e);
        }, m.get = function (t) {
          return this[b.p(t)]();
        }, m.add = function (r, f) {
          var d,
            l = this;
          r = Number(r);
          var $ = b.p(f),
            y = function y(t) {
              var e = O(l);
              return b.w(e.date(e.date() + Math.round(t * r)), l);
            };
          if ($ === c) return this.set(c, this.$M + r);
          if ($ === h) return this.set(h, this.$y + r);
          if ($ === a) return y(1);
          if ($ === o) return y(7);
          var M = (d = {}, d[s] = e, d[u] = n, d[i] = t, d)[$] || 1,
            m = this.$d.getTime() + r * M;
          return b.w(m, this);
        }, m.subtract = function (t, e) {
          return this.add(-1 * t, e);
        }, m.format = function (t) {
          var e = this,
            n = this.$locale();
          if (!this.isValid()) return n.invalidDate || l;
          var r = t || "YYYY-MM-DDTHH:mm:ssZ",
            i = b.z(this),
            s = this.$H,
            u = this.$m,
            a = this.$M,
            o = n.weekdays,
            c = n.months,
            f = n.meridiem,
            h = function h(t, n, i, s) {
              return t && (t[n] || t(e, r)) || i[n].slice(0, s);
            },
            d = function d(t) {
              return b.s(s % 12 || 12, t, "0");
            },
            $ = f || function (t, e, n) {
              var r = t < 12 ? "AM" : "PM";
              return n ? r.toLowerCase() : r;
            };
          return r.replace(y, function (t, r) {
            return r || function (t) {
              switch (t) {
                case "YY":
                  return String(e.$y).slice(-2);
                case "YYYY":
                  return b.s(e.$y, 4, "0");
                case "M":
                  return a + 1;
                case "MM":
                  return b.s(a + 1, 2, "0");
                case "MMM":
                  return h(n.monthsShort, a, c, 3);
                case "MMMM":
                  return h(c, a);
                case "D":
                  return e.$D;
                case "DD":
                  return b.s(e.$D, 2, "0");
                case "d":
                  return String(e.$W);
                case "dd":
                  return h(n.weekdaysMin, e.$W, o, 2);
                case "ddd":
                  return h(n.weekdaysShort, e.$W, o, 3);
                case "dddd":
                  return o[e.$W];
                case "H":
                  return String(s);
                case "HH":
                  return b.s(s, 2, "0");
                case "h":
                  return d(1);
                case "hh":
                  return d(2);
                case "a":
                  return $(s, u, !0);
                case "A":
                  return $(s, u, !1);
                case "m":
                  return String(u);
                case "mm":
                  return b.s(u, 2, "0");
                case "s":
                  return String(e.$s);
                case "ss":
                  return b.s(e.$s, 2, "0");
                case "SSS":
                  return b.s(e.$ms, 3, "0");
                case "Z":
                  return i;
              }
              return null;
            }(t) || i.replace(":", "");
          });
        }, m.utcOffset = function () {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, m.diff = function (r, d, l) {
          var $,
            y = this,
            M = b.p(d),
            m = O(r),
            v = (m.utcOffset() - this.utcOffset()) * e,
            g = this - m,
            D = function D() {
              return b.m(y, m);
            };
          switch (M) {
            case h:
              $ = D() / 12;
              break;
            case c:
              $ = D();
              break;
            case f:
              $ = D() / 3;
              break;
            case o:
              $ = (g - v) / 6048e5;
              break;
            case a:
              $ = (g - v) / 864e5;
              break;
            case u:
              $ = g / n;
              break;
            case s:
              $ = g / e;
              break;
            case i:
              $ = g / t;
              break;
            default:
              $ = g;
          }
          return l ? $ : b.a($);
        }, m.daysInMonth = function () {
          return this.endOf(c).$D;
        }, m.$locale = function () {
          return D[this.$L];
        }, m.locale = function (t, e) {
          if (!t) return this.$L;
          var n = this.clone(),
            r = w(t, e, !0);
          return r && (n.$L = r), n;
        }, m.clone = function () {
          return b.w(this.$d, this);
        }, m.toDate = function () {
          return new Date(this.valueOf());
        }, m.toJSON = function () {
          return this.isValid() ? this.toISOString() : null;
        }, m.toISOString = function () {
          return this.$d.toISOString();
        }, m.toString = function () {
          return this.$d.toUTCString();
        }, M;
      }(),
      k = _.prototype;
    return O.prototype = k, [["$ms", r], ["$s", i], ["$m", s], ["$H", u], ["$W", a], ["$M", c], ["$y", h], ["$D", d]].forEach(function (t) {
      k[t[1]] = function (e) {
        return this.$g(e, t[0], t[1]);
      };
    }), O.extend = function (t, e) {
      return t.$i || (t(e, _, O), t.$i = !0), O;
    }, O.locale = w, O.isDayjs = S, O.unix = function (t) {
      return O(1e3 * t);
    }, O.en = D[g], O.Ls = D, O.p = {}, O;
  });
})(dayjs_min);

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};
var queryTypes = {
  search: 'search',
  term: 'term',
  range: 'range',
  geo: 'geo',
  suggestion: 'suggestion'
};
var AI_ROLES = {
  USER: 'user',
  SYSTEM: 'system',
  ASSISTANT: 'assistant'
};
var AI_LOCAL_CACHE_KEY = 'AISessions';

var _componentTypeToDefau;
(_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));

// utils/localStorage.js

var setObjectInLocalStorage = function setObjectInLocalStorage(key, value) {
  if (typeof localStorage !== 'undefined') {
    if (!key || !value) {
      throw new Error('Key and value are required for setObject');
    }
    try {
      var serializedValue = JSON.stringify(value);
      localStorage.setItem(key, serializedValue);
    } catch (error) {
      console.error('Error saving object to localStorage:', error);
    }
  } else {
    console.warn('localstorage not available');
  }
};
var getObjectFromLocalStorage = function getObjectFromLocalStorage(key) {
  if (!key) {
    throw new Error('Key is required for getObject');
  }
  try {
    var serializedValue = localStorage.getItem(key);
    if (serializedValue === null) {
      return null;
    }
    return JSON.parse(serializedValue);
  } catch (error) {
    console.error('Error retrieving object from localStorage:', error);
    return null;
  }
};

// Just for debuggin
// Call this function inside the function for which
// a stack trace is needed
function getStackTrace() {
  var error = new Error();
  // eslint-disable-next-line no-console
  console.log(error.stack);
}

var _componentToTypeMap;
(_componentToTypeMap = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.reactiveList, queryTypes.search), componentTypes.dataSearch, queryTypes.search), componentTypes.categorySearch, queryTypes.search), componentTypes.searchBox, queryTypes.suggestion), componentTypes.AIAnswer, queryTypes.search), componentTypes.singleList, queryTypes.term), componentTypes.multiList, queryTypes.term), componentTypes.singleDataList, queryTypes.term), componentTypes.singleDropdownList, queryTypes.term), componentTypes.multiDataList, queryTypes.term), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownList, queryTypes.term), componentTypes.tagCloud, queryTypes.term), componentTypes.toggleButton, queryTypes.term), componentTypes.reactiveChart, queryTypes.term), componentTypes.treeList, queryTypes.term), componentTypes.numberBox, queryTypes.term), componentTypes.datePicker, queryTypes.range), componentTypes.dateRange, queryTypes.range), componentTypes.dynamicRangeSlider, queryTypes.range), componentTypes.singleDropdownRange, queryTypes.range), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownRange, queryTypes.range), componentTypes.singleRange, queryTypes.range), componentTypes.multiRange, queryTypes.range), componentTypes.rangeSlider, queryTypes.range), componentTypes.ratingsFilter, queryTypes.range), componentTypes.rangeInput, queryTypes.range), componentTypes.geoDistanceDropdown, queryTypes.geo), componentTypes.geoDistanceSlider, queryTypes.geo), componentTypes.reactiveMap, queryTypes.geo));
var getInternalComponentID = function getInternalComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__internal");
};

var SET_QUERY_TO_HITS = 'SET_QUERY_TO_HITS';

function updateAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateCompositeAggs(component, aggregations) {
  var append = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return {
    type: UPDATE_COMPOSITE_AGGS,
    component: component,
    aggregations: aggregations,
    append: append
  };
}
function updateHits(component, hits, time, hidden) {
  var append = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return {
    type: UPDATE_HITS,
    component: component,
    hits: hits.hits,
    // make compatible with es7
    total: _typeof(hits.total) === 'object' ? hits.total.value : hits.total,
    hidden: hidden,
    time: time,
    append: append
  };
}
function saveQueryToHits(component, query) {
  return {
    type: SET_QUERY_TO_HITS,
    component: component,
    query: query
  };
}

function setRawData(component, response) {
  return {
    type: SET_RAW_DATA,
    component: component,
    response: response
  };
}
function setLoading(component, isLoading) {
  return {
    type: SET_LOADING,
    component: component,
    isLoading: isLoading
  };
}
function setError(component, error) {
  return {
    type: SET_ERROR,
    component: component,
    error: error
  };
}
function setTimestamp(component, timestamp) {
  return {
    type: SET_TIMESTAMP,
    component: component,
    timestamp: timestamp
  };
}
function setSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SEARCH_ID,
    searchId: searchId
  };
}
function setSuggestionsSearchId() {
  var searchId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  return {
    type: SET_SUGGESTIONS_SEARCH_ID,
    searchId: searchId
  };
}
function setPromotedResults() {
  var results = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_PROMOTED_RESULTS,
    results: results,
    component: component
  };
}
function setCustomData() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_CUSTOM_DATA,
    data: data,
    component: component
  };
}
function setAppliedSettings() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var component = arguments.length > 1 ? arguments[1] : undefined;
  return {
    type: SET_APPLIED_SETTINGS,
    data: data,
    component: component
  };
}
function setLastUsedAppbaseQuery(query) {
  return {
    type: SET_APPBASE_QUERY,
    query: query
  };
}
function setAIResponse(component, payload) {
  return {
    type: SET_AI_RESPONSE,
    component: component,
    payload: payload
  };
}
function setAIResponseDelayed(component, payload) {
  return {
    type: SET_AI_RESPONSE_DELAYED,
    component: component,
    payload: payload
  };
}
function setAIResponseError(component, error) {
  var meta = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return {
    type: SET_AI_RESPONSE_ERROR,
    component: component,
    error: error,
    meta: meta
  };
}
function setAIResponseLoading(component, isLoading) {
  return {
    type: SET_AI_RESPONSE_LOADING,
    component: component,
    isLoading: isLoading
  };
}

function ownKeys$1(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread$1(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys$1(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys$1(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function processJSONResponse(dispatch, componentId, AIAnswerKey, localCache, parsedRes) {
  var meta = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
  try {
    var finalResponse = _objectSpread$1({}, parsedRes);
    if (finalResponse.answer) {
      finalResponse.answer.role = AI_ROLES.ASSISTANT;
    }
    dispatch(setAIResponse(componentId, {
      meta: meta,
      sessionId: AIAnswerKey,
      messages: [].concat(_toConsumableArray(localCache && localCache.messages || []), _toConsumableArray(finalResponse.question ? [{
        content: finalResponse.question,
        role: AI_ROLES.USER
      }] : []), _toConsumableArray(finalResponse.answer ? [{
        content: finalResponse.answer.text,
        role: AI_ROLES.ASSISTANT
      }] : [])),
      response: _objectSpread$1({}, finalResponse)
    }));
  } catch (e) {
    getStackTrace();
    dispatch(setAIResponseError(componentId, e, {
      sessionId: AIAnswerKey
    }));
  }
}
function processStream(res, dispatch, componentId, AIAnswerKey) {
  var meta = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var question = arguments.length > 5 ? arguments[5] : undefined;
  var metaInfoPromise = arguments.length > 6 ? arguments[6] : undefined;
  var reader = res.body.getReader();
  var decoder = new TextDecoder();
  var responseText = '';
  var answerIndex;
  var questionMessage = question ? {
    content: question,
    role: AI_ROLES.USER
  } : null;
  var updateMessage = function updateMessage(content) {
    responseText += content;
    var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[componentId];
    var messages = _toConsumableArray(localCache && localCache.messages || localCache && localCache.response && localCache.response.messages || []);
    if (questionMessage && messages.findIndex(function (msg) {
      return msg.content === questionMessage.content && msg.role === questionMessage.role;
    }) === -1) {
      messages.push(questionMessage);
    }
    if (answerIndex === undefined) {
      answerIndex = messages.length;
      messages.push({
        content: responseText,
        role: AI_ROLES.ASSISTANT
      });
    } else {
      messages[answerIndex] = {
        content: responseText,
        role: AI_ROLES.ASSISTANT
      };
    }
    dispatch(setAIResponseDelayed(componentId, {
      meta: meta,
      sessionId: AIAnswerKey,
      isTyping: true,
      messages: messages,
      response: {
        answer: {
          text: responseText,
          role: AI_ROLES.ASSISTANT
        }
      }
    }));
  };
  function readStream() {
    reader.read().then(function (_ref3) {
      var value = _ref3.value,
        done = _ref3.done;
      if (done) {
        reader.releaseLock();
        return;
      }
      var chunk = decoder.decode(value, {
        stream: true
      });
      var regex = /\n\n(?=data:|$)/;
      var lines = chunk.split(regex);
      var shouldStop = false;
      for (var i = 0; i < lines.length; i++) {
        var line = lines[i];
        if (line.startsWith('data: ')) {
          var content = line.slice(6);
          if (content === '[DONE]') {
            shouldStop = true;
            if (Promise.resolve(metaInfoPromise) === metaInfoPromise) {
              metaInfoPromise.then(function (resMeta) {
                return resMeta.json();
              })
              // eslint-disable-next-line no-loop-func
              .then(function (parsedRes) {
                var messagesArr = [];
                if (parsedRes.question && parsedRes.answer) {
                  messagesArr.push.apply(messagesArr, [{
                    content: parsedRes.question,
                    role: AI_ROLES.USER
                  }, {
                    content: parsedRes.answer.text,
                    role: AI_ROLES.ASSISTANT
                  }]);
                }
                dispatch(setAIResponseDelayed(componentId, {
                  meta: meta,
                  sessionId: AIAnswerKey,
                  response: _objectSpread$1({}, parsedRes),
                  messages: messagesArr,
                  isTyping: false
                }));
              })["catch"](function (e) {
                console.error("Error fetching meta details for sessionId: ".concat(AIAnswerKey), e);
              });
            } else {
              dispatch(setAIResponseDelayed(componentId, {
                isTyping: false
              }));
            }
            break;
          }
          updateMessage(content);
        }
      }
      if (shouldStop) {
        reader.releaseLock();
      } else {
        readStream();
      }
    })["catch"](function (e) {
      reader.releaseLock();
      dispatch(setAIResponseError(componentId, e, {
        sessionId: AIAnswerKey,
        isTyping: false
      }));
    });
  }
  readStream();
}
var cancellationTokens = {}; // initialize cancellationTokens map

function fetchAIResponse(AIAnswerKey, componentId, question) {
  var meta = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var shouldFetchMetaInfoUsingGET = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  return function (dispatch, getState) {
    var isPostRequest = !!question;
    dispatch(setAIResponseLoading(componentId, true));
    var _getState6 = getState(),
      _getState6$config = _getState6.config,
      url = _getState6$config.url,
      configCredentials = _getState6$config.credentials,
      endpoint = _getState6$config.endpoint;
    var regex = /https:\/\/[^/]+/;
    var urlObj = new URL(url.match(regex)[0]);
    var credentials = configCredentials;
    if (urlObj.username && urlObj.password) {
      credentials = "".concat(urlObj.username, ":").concat(urlObj.password);
      urlObj.username = '';
      urlObj.password = '';
    }
    var fetchUrl = "".concat(urlObj.toString(), "_ai/").concat(AIAnswerKey);
    var ssefetchUrl = "".concat(fetchUrl, "/sse");
    var headers = new Headers();
    if (credentials) {
      var encodedCredentials = btoa(credentials);
      headers.append('Authorization', "Basic ".concat(encodedCredentials));
    } else if (endpoint && endpoint.headers && endpoint.headers.Authorization) {
      headers.append('Authorization', endpoint.headers.Authorization);
    }
    var method = isPostRequest ? 'POST' : 'GET';
    var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[componentId];
    var requestOptions = {
      headers: headers,
      method: method,
      body: isPostRequest ? JSON.stringify({
        question: question
      }) : undefined
    };
    var attempt = 1; // initialize attempt number
    var maxAttempts = 2; // set max number of attempts

    var doFetch = function doFetch() {
      // Create a new cancellation token for this componentId
      // and abort any previous requests for this componentId
      var controller = new AbortController();
      if (cancellationTokens[componentId]) {
        cancellationTokens[componentId].abort();
      }
      cancellationTokens[componentId] = controller;
      fetch(ssefetchUrl, _objectSpread$1(_objectSpread$1({}, requestOptions), {}, {
        signal: controller.signal
      })).then(function (res) {
        if (!res.ok) {
          if (attempt < maxAttempts) {
            // retry on 400 error, up to maxAttempts times
            attempt++;
            setTimeout(doFetch, 1000); // retry
            return;
          }
        }
        var contentType = res.headers.get('content-type');
        if (contentType && contentType.startsWith('application/json')) {
          res.json().then(function (parsedRes) {
            if (parsedRes.error) {
              dispatch(setAIResponseError(componentId, parsedRes.error));
            } else {
              processJSONResponse(dispatch, componentId, AIAnswerKey, localCache, parsedRes, meta);
            }
          });
        } else {
          var metaInfoPromise;
          if (shouldFetchMetaInfoUsingGET) {
            metaInfoPromise = fetch(fetchUrl, _objectSpread$1(_objectSpread$1({}, requestOptions.headers ? {
              headers: requestOptions.headers
            } : {}), {}, {
              method: 'GET'
            }));
          }
          processStream(res, dispatch, componentId, AIAnswerKey, meta, question, metaInfoPromise);
        }
      })["catch"](function (e) {
        // Ignore abort errors
        if (e.name === 'AbortError') {
          return;
        }
        dispatch(setAIResponseError(componentId, e, {
          sessionId: AIAnswerKey
        }));
      });
    };
    doFetch();
  };
}

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var handleTransformResponse = function handleTransformResponse() {
  var res = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var component = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  if (config.transformResponse && typeof config.transformResponse === 'function') {
    return config.transformResponse(res, component);
  }
  return new Promise(function (resolve) {
    return resolve(res);
  });
};

// Checks if a component is active or not at a particular time
var isComponentActive = function isComponentActive() {
  var getState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var componentId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var _getState = getState(),
    components = _getState.components;
  if (components.includes(componentId)) {
    return true;
  }
  return false;
};
var getQuerySuggestionsId = function getQuerySuggestionsId() {
  var componentId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentId, "__suggestions");
};
var handleError = function handleError() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref$orderOfQueries = _ref.orderOfQueries,
    orderOfQueries = _ref$orderOfQueries === void 0 ? [] : _ref$orderOfQueries,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? null : _ref$error;
  var getState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var dispatch = arguments.length > 2 ? arguments[2] : undefined;
  var _getState2 = getState(),
    queryListener = _getState2.queryListener;
  try {
    console.error(JSON.stringify(error));
  } catch (e) {
    console.error(error);
  }
  orderOfQueries.forEach(function (component) {
    if (isComponentActive(getState, component)) {
      // Only update state for active components
      if (queryListener[component] && queryListener[component].onError) {
        queryListener[component].onError(error);
      }
      dispatch(setError(component, error));
      dispatch(setLoading(component, false));
    }
  });
};
var handleResponse = function handleResponse() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    res = _ref2.res,
    _ref2$orderOfQueries = _ref2.orderOfQueries,
    orderOfQueries = _ref2$orderOfQueries === void 0 ? [] : _ref2$orderOfQueries,
    _ref2$appendToHits = _ref2.appendToHits,
    appendToHits = _ref2$appendToHits === void 0 ? false : _ref2$appendToHits,
    _ref2$appendToAggs = _ref2.appendToAggs,
    appendToAggs = _ref2$appendToAggs === void 0 ? false : _ref2$appendToAggs,
    _ref2$isSuggestionsQu = _ref2.isSuggestionsQuery,
    isSuggestionsQuery = _ref2$isSuggestionsQu === void 0 ? false : _ref2$isSuggestionsQu,
    query = _ref2.query,
    queryId = _ref2.queryId;
  var getState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  var dispatch = arguments.length > 2 ? arguments[2] : undefined;
  var _getState3 = getState(),
    config = _getState3.config,
    internalValues = _getState3.internalValues,
    lastUsedAppbaseQuery = _getState3.lastUsedAppbaseQuery,
    analyticsRef = _getState3.analyticsRef;
  var searchId = res._headers ? res._headers.get('X-Search-Id') : null;
  if (searchId) {
    if (isSuggestionsQuery) {
      // set suggestions search id for internal request of search components
      dispatch(setSuggestionsSearchId(searchId));
    } else {
      // if search id was updated set it in store
      dispatch(setSearchId(searchId));
      if (analyticsRef) {
        analyticsRef.queryID = searchId;
      }
    }
  }

  // handle promoted results
  orderOfQueries.forEach(function (component) {
    // Only update state for active components
    if (isComponentActive(getState, component)) {
      // Avoid settings stale results
      if (lastUsedAppbaseQuery[component] && lastUsedAppbaseQuery[component].queryId && queryId && lastUsedAppbaseQuery[component].queryId !== queryId) {
        return;
      }
      // Update applied settings
      if (res.settings) {
        dispatch(setAppliedSettings(res.settings, component));
      }
      handleTransformResponse(res[component], config, component).then(function (response) {
        if (response) {
          var _getState4 = getState(),
            timestamp = _getState4.timestamp,
            props = _getState4.props;
          if (timestamp[component] === undefined || timestamp[component] < res._timestamp || response.AISessionId && props[component].enableAI && props[component].componentType === componentTypes.searchBox) {
            var promotedResults = response.promoted;
            if (promotedResults) {
              var parsedPromotedResults = promotedResults.map(function (promoted) {
                return _objectSpread(_objectSpread({}, promoted.doc), {}, {
                  _position: promoted.position
                });
              });
              dispatch(setPromotedResults(parsedPromotedResults, component));
            } else {
              dispatch(setPromotedResults([], component));
            }
            // set raw response in rawData
            dispatch(setRawData(component, response));
            if (response.AIAnswer) {
              if (response.AIAnswer.error) {
                dispatch(setAIResponseError(component, {
                  message: response.AIAnswer.error
                }));
                dispatch(setLoading(component, false));
                return;
              }
              var input = response.AIAnswer;
              // store direct answer returned from API call
              var finalResponse = {
                answer: {
                  documentIds: input.documentIds,
                  model: input.model,
                  text: input.choices[0].message.content
                }
              };
              var finalResponseObj = {
                response: finalResponse,
                meta: response.hits,
                isTyping: false
              };
              if (response.AISessionId) {
                finalResponseObj.sessionId = response.AISessionId;
              }
              dispatch(setAIResponse(component, finalResponseObj));
            } else if (response.AISessionId) {
              var localCache = (getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {})[props.componentId];
              if (localCache && localCache.sessionId && localCache.sessionId === response.AISessionId) {
                // hydrate the store from cache
                dispatch(setAIResponse(component, localCache));
              } else {
                // delete localCache
                setObjectInLocalStorage('AISessions', _defineProperty({}, component, {}));

                // rely on trigger from within the component
                // to fetch initial result for AIAnswer component
                if (props[component].componentType === componentTypes.AIAnswer) {
                  dispatch(setAIResponse(component, {
                    sessionId: response.AISessionId,
                    meta: {
                      hits: response.hits || {}
                    }
                  }));
                } else {
                  // fetch initial AIResponse
                  dispatch(fetchAIResponse(response.AISessionId, component, '', {
                    hits: response.hits || {}
                  }, props[component].componentType === componentTypes.searchBox || props[component].componentType === componentTypes.AIAnswer // make extra GET call to fetch meta info
                  ));
                }
              }
            }

            // Update custom data
            dispatch(setCustomData(response.customData, component));
            if (response.hits && !((response.AIAnswer || response.AISessionId) && props[component].componentType === componentTypes.searchBox)) {
              dispatch(setTimestamp(component, res._timestamp));
              // store last used query for REACTIVE_LIST only

              if (props[component].componentType === componentTypes.reactiveList && query.find(function (queryItem) {
                return queryItem.id === component;
              }).execute) {
                dispatch(setLastUsedAppbaseQuery(_defineProperty({}, component, query)));
              }
              dispatch(updateHits(component, response.hits, response.took, response.hits && response.hits.hidden, appendToHits));
              // get query value
              var internalComponentID = getInternalComponentID(component);
              // Store the last query value associated with `hits`
              if (internalValues[internalComponentID]) {
                dispatch(saveQueryToHits(component, internalValues[internalComponentID].value));
              }
            }
            if (response.aggregations) {
              dispatch(updateAggs(component, response.aggregations, appendToAggs));
              dispatch(updateCompositeAggs(component, response.aggregations, appendToAggs));
            }
          }
          dispatch(setLoading(component, false));
        }
      })["catch"](function (err) {
        handleError({
          orderOfQueries: orderOfQueries,
          error: err
        }, getState, dispatch);
      });
    }
    // }
  });
};
var isPropertyDefined = function isPropertyDefined(property) {
  return property !== undefined && property !== null;
};
var getSuggestionQuery = function getSuggestionQuery() {
  var getState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var componentId = arguments.length > 1 ? arguments[1] : undefined;
  var _getState5 = getState(),
    internalValues = _getState5.internalValues;
  var internalValue = internalValues[componentId];
  var value = internalValue && internalValue.value || '';
  return [{
    id: getQuerySuggestionsId(componentId),
    dataField: ['key', 'key.autosuggest'],
    size: 5,
    value: value,
    defaultQuery: {
      query: {
        bool: {
          minimum_should_match: 1,
          should: [{
            function_score: {
              field_value_factor: {
                field: 'count',
                modifier: 'sqrt',
                missing: 1
              }
            }
          }, {
            multi_match: {
              fields: ['key^9', 'key.autosuggest^1', 'key.keyword^10'],
              fuzziness: 0,
              operator: 'or',
              query: value,
              type: 'best_fields'
            }
          }, {
            multi_match: {
              fields: ['key^9', 'key.autosuggest^1', 'key.keyword^10'],
              operator: 'or',
              query: value,
              type: 'phrase'
            }
          }, {
            multi_match: {
              fields: ['key^9'],
              operator: 'or',
              query: value,
              type: 'phrase_prefix'
            }
          }]
        }
      }
    }
  }];
};
function executeQueryListener(listener, oldQuery, newQuery) {
  if (listener && listener.onQueryChange) {
    listener.onQueryChange(oldQuery, newQuery);
  }
}
function updateStoreConfig(payload) {
  return function (dispatch) {
    dispatch({
      type: UPDATE_CONFIG,
      config: payload
    });
  };
}

export { executeQueryListener, getQuerySuggestionsId, getSuggestionQuery, handleError, handleResponse, handleTransformResponse, isComponentActive, isPropertyDefined, updateStoreConfig };
