'use strict';

var ADD_COMPONENT = 'ADD_COMPONENT';
var REMOVE_COMPONENT = 'REMOVE_COMPONENT';
var WATCH_COMPONENT = 'WATCH_COMPONENT';
var SET_QUERY = 'SET_QUERY';
var SET_APPBASE_QUERY = 'SET_APPBASE_QUERY';
var SET_QUERY_OPTIONS = 'SET_QUERY_OPTIONS';
var EXECUTE_QUERY = 'EXECUTE_QUERY';
var UPDATE_HITS = 'UPDATE_HITS';
var UPDATE_AGGS = 'UPDATE_AGGS';
var UPDATE_COMPOSITE_AGGS = 'UPDATE_COMPOSITE_AGGS';
var ADD_CONFIG = 'ADD_CONFIG';
var UPDATE_CONFIG = 'UPDATE_CONFIG';
var ADD_APPBASE_REF = 'ADD_APPBASE_REF';
var ADD_ANALYTICS_REF = 'ADD_ANALYTICS_REF';
var LOG_QUERY = 'LOG_QUERY';
var LOG_COMBINED_QUERY = 'LOG_COMBINED_QUERY';
var SET_INTERNAL_VALUE = 'SET_INTERNAL_VALUE';
var PATCH_VALUE = 'PATCH_VALUE';
var CLEAR_VALUES = 'CLEAR_VALUES';
var SET_LOADING = 'SET_LOADING';
var SET_ERROR = 'SET_ERROR';
var SET_TIMESTAMP = 'SET_TIMESTAMP';
var SET_HEADERS = 'SET_HEADERS';
var SET_MAP_DATA = 'SET_MAP_DATA';
var SET_MAP_RESULTS = 'SET_MAP_RESULTS';
var SET_QUERY_LISTENER = 'SET_QUERY_LISTENER';
var STORE_KEY = '__REACTIVESEARCH__';
var SET_SEARCH_ID = 'SET_SEARCH_ID';
var SET_PROMOTED_RESULTS = 'SET_PROMOTED_RESULTS';
var SET_DEFAULT_QUERY = 'SET_DEFAULT_QUERY';
var SET_CUSTOM_QUERY = 'SET_CUSTOM_QUERY';
var SET_CUSTOM_HIGHLIGHT_OPTIONS = 'SET_CUSTOM_HIGHLIGHT_OPTIONS';
var SET_CUSTOM_DATA = 'SET_CUSTOM_DATA';
var SET_APPLIED_SETTINGS = 'SET_APPLIED_SETTINGS';
var SET_PROPS = 'SET_PROPS';
var UPDATE_PROPS = 'UPDATE_PROPS';
var REMOVE_PROPS = 'REMOVE_PROPS';
var SET_SUGGESTIONS_SEARCH_VALUE = 'SET_SUGGESTIONS_SEARCH_VALUE';
var CLEAR_SUGGESTIONS_SEARCH_VALUE = 'CLEAR_SUGGESTIONS_SEARCH_VALUE';
var SET_SUGGESTIONS_SEARCH_ID = 'SET_SUGGESTIONS_SEARCH_ID';
var UPDATE_ANALYTICS_CONFIG = 'UPDATE_ANALYTICS_CONFIG';
var SET_RAW_DATA = 'SET_RAW_DATA';
var SET_POPULAR_SUGGESTIONS = 'SET_POPULAR_SUGGESTIONS';
var SET_DEFAULT_POPULAR_SUGGESTIONS = 'SET_DEFAULT_POPULAR_SUGGESTIONS';
var SET_QUERY_TO_HITS = 'SET_QUERY_TO_HITS';
var RECENT_SEARCHES_SUCCESS = 'RECENT_SEARCHES_SUCCESS';
var RECENT_SEARCHES_ERROR = 'RECENT_SEARCHES_ERROR';
var SET_VALUE = 'SET_VALUE';
var SET_VALUES = 'SET_VALUES';
var RESET_TO_DEFAULT = 'RESET_TO_DEFAULT';
var SET_GOOGLE_MAP_SCRIPT_LOADING = 'SET_GOOGLE_MAP_SCRIPT_LOADING';
var SET_GOOGLE_MAP_SCRIPT_LOADED = 'SET_GOOGLE_MAP_SCRIPT_LOADED';
var SET_GOOGLE_MAP_SCRIPT_ERROR = 'SET_GOOGLE_MAP_SCRIPT_ERROR';
var SET_REGISTERED_COMPONENT_TIMESTAMP = 'SET_REGISTERED_COMPONENT_TIMESTAMP';
var REMOVE_REGISTERED_COMPONENT_TIMESTAMP = 'REMOVE_REGISTERED_COMPONENT_TIMESTAMP';
var SET_AI_RESPONSE = 'SET_AI_RESPONSE';
var SET_AI_RESPONSE_DELAYED = 'SET_AI_RESPONSE_DELAYED';
var REMOVE_AI_RESPONSE = 'REMOVE_AI_RESPONSE';
var SET_AI_RESPONSE_ERROR = 'SET_AI_RESPONSE_ERROR';
var SET_AI_RESPONSE_LOADING = 'SET_AI_RESPONSE_LOADING';

exports.ADD_ANALYTICS_REF = ADD_ANALYTICS_REF;
exports.ADD_APPBASE_REF = ADD_APPBASE_REF;
exports.ADD_COMPONENT = ADD_COMPONENT;
exports.ADD_CONFIG = ADD_CONFIG;
exports.CLEAR_SUGGESTIONS_SEARCH_VALUE = CLEAR_SUGGESTIONS_SEARCH_VALUE;
exports.CLEAR_VALUES = CLEAR_VALUES;
exports.EXECUTE_QUERY = EXECUTE_QUERY;
exports.LOG_COMBINED_QUERY = LOG_COMBINED_QUERY;
exports.LOG_QUERY = LOG_QUERY;
exports.PATCH_VALUE = PATCH_VALUE;
exports.RECENT_SEARCHES_ERROR = RECENT_SEARCHES_ERROR;
exports.RECENT_SEARCHES_SUCCESS = RECENT_SEARCHES_SUCCESS;
exports.REMOVE_AI_RESPONSE = REMOVE_AI_RESPONSE;
exports.REMOVE_COMPONENT = REMOVE_COMPONENT;
exports.REMOVE_PROPS = REMOVE_PROPS;
exports.REMOVE_REGISTERED_COMPONENT_TIMESTAMP = REMOVE_REGISTERED_COMPONENT_TIMESTAMP;
exports.RESET_TO_DEFAULT = RESET_TO_DEFAULT;
exports.SET_AI_RESPONSE = SET_AI_RESPONSE;
exports.SET_AI_RESPONSE_DELAYED = SET_AI_RESPONSE_DELAYED;
exports.SET_AI_RESPONSE_ERROR = SET_AI_RESPONSE_ERROR;
exports.SET_AI_RESPONSE_LOADING = SET_AI_RESPONSE_LOADING;
exports.SET_APPBASE_QUERY = SET_APPBASE_QUERY;
exports.SET_APPLIED_SETTINGS = SET_APPLIED_SETTINGS;
exports.SET_CUSTOM_DATA = SET_CUSTOM_DATA;
exports.SET_CUSTOM_HIGHLIGHT_OPTIONS = SET_CUSTOM_HIGHLIGHT_OPTIONS;
exports.SET_CUSTOM_QUERY = SET_CUSTOM_QUERY;
exports.SET_DEFAULT_POPULAR_SUGGESTIONS = SET_DEFAULT_POPULAR_SUGGESTIONS;
exports.SET_DEFAULT_QUERY = SET_DEFAULT_QUERY;
exports.SET_ERROR = SET_ERROR;
exports.SET_GOOGLE_MAP_SCRIPT_ERROR = SET_GOOGLE_MAP_SCRIPT_ERROR;
exports.SET_GOOGLE_MAP_SCRIPT_LOADED = SET_GOOGLE_MAP_SCRIPT_LOADED;
exports.SET_GOOGLE_MAP_SCRIPT_LOADING = SET_GOOGLE_MAP_SCRIPT_LOADING;
exports.SET_HEADERS = SET_HEADERS;
exports.SET_INTERNAL_VALUE = SET_INTERNAL_VALUE;
exports.SET_LOADING = SET_LOADING;
exports.SET_MAP_DATA = SET_MAP_DATA;
exports.SET_MAP_RESULTS = SET_MAP_RESULTS;
exports.SET_POPULAR_SUGGESTIONS = SET_POPULAR_SUGGESTIONS;
exports.SET_PROMOTED_RESULTS = SET_PROMOTED_RESULTS;
exports.SET_PROPS = SET_PROPS;
exports.SET_QUERY = SET_QUERY;
exports.SET_QUERY_LISTENER = SET_QUERY_LISTENER;
exports.SET_QUERY_OPTIONS = SET_QUERY_OPTIONS;
exports.SET_QUERY_TO_HITS = SET_QUERY_TO_HITS;
exports.SET_RAW_DATA = SET_RAW_DATA;
exports.SET_REGISTERED_COMPONENT_TIMESTAMP = SET_REGISTERED_COMPONENT_TIMESTAMP;
exports.SET_SEARCH_ID = SET_SEARCH_ID;
exports.SET_SUGGESTIONS_SEARCH_ID = SET_SUGGESTIONS_SEARCH_ID;
exports.SET_SUGGESTIONS_SEARCH_VALUE = SET_SUGGESTIONS_SEARCH_VALUE;
exports.SET_TIMESTAMP = SET_TIMESTAMP;
exports.SET_VALUE = SET_VALUE;
exports.SET_VALUES = SET_VALUES;
exports.STORE_KEY = STORE_KEY;
exports.UPDATE_AGGS = UPDATE_AGGS;
exports.UPDATE_ANALYTICS_CONFIG = UPDATE_ANALYTICS_CONFIG;
exports.UPDATE_COMPOSITE_AGGS = UPDATE_COMPOSITE_AGGS;
exports.UPDATE_CONFIG = UPDATE_CONFIG;
exports.UPDATE_HITS = UPDATE_HITS;
exports.UPDATE_PROPS = UPDATE_PROPS;
exports.WATCH_COMPONENT = WATCH_COMPONENT;
