function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var SET_AI_RESPONSE = 'SET_AI_RESPONSE';
var REMOVE_AI_RESPONSE = 'REMOVE_AI_RESPONSE';
var SET_AI_RESPONSE_ERROR = 'SET_AI_RESPONSE_ERROR';
var SET_AI_RESPONSE_LOADING = 'SET_AI_RESPONSE_LOADING';

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};
var AI_LOCAL_CACHE_KEY = 'AISessions';

var _componentTypeToDefau;
(_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));

// utils/localStorage.js

var setObjectInLocalStorage = function setObjectInLocalStorage(key, value) {
  if (typeof localStorage !== 'undefined') {
    if (!key || !value) {
      throw new Error('Key and value are required for setObject');
    }
    try {
      var serializedValue = JSON.stringify(value);
      localStorage.setItem(key, serializedValue);
    } catch (error) {
      console.error('Error saving object to localStorage:', error);
    }
  } else {
    console.warn('localstorage not available');
  }
};
var getObjectFromLocalStorage = function getObjectFromLocalStorage(key) {
  if (!key) {
    throw new Error('Key is required for getObject');
  }
  try {
    var serializedValue = localStorage.getItem(key);
    if (serializedValue === null) {
      return null;
    }
    return JSON.parse(serializedValue);
  } catch (error) {
    console.error('Error retrieving object from localStorage:', error);
    return null;
  }
};

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function aiReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === SET_AI_RESPONSE) {
    setObjectInLocalStorage('AISessions', _objectSpread(_objectSpread({}, getObjectFromLocalStorage(AI_LOCAL_CACHE_KEY) || {}), {}, _defineProperty({}, action.component, _objectSpread(_objectSpread({}, state[action.component] || {}), action.payload))));
    return _objectSpread(_objectSpread({}, state), {}, _defineProperty({}, action.component, _objectSpread(_objectSpread({}, state[action.component] ? state[action.component] : {}), {}, {
      response: _objectSpread(_objectSpread({}, state[action.component] ? state[action.component].response : {}), action.payload),
      isLoading: false,
      error: null
    })));
  } else if (action.type === REMOVE_AI_RESPONSE) {
    var _action$component = action.component;
      state[_action$component];
      var obj = _objectWithoutProperties(state, [_action$component].map(_toPropertyKey));
    return obj;
  } else if (action.type === SET_AI_RESPONSE_ERROR) {
    return _objectSpread(_objectSpread({}, state), {}, _defineProperty({}, action.component, _objectSpread(_objectSpread({}, state[action.component] ? state[action.component] : {}), {}, {
      error: action.error,
      isLoading: false,
      response: null
    }, action.meta || {})));
  } else if (action.type === SET_AI_RESPONSE_LOADING) {
    return _objectSpread(_objectSpread({}, state), {}, _defineProperty({}, action.component, _objectSpread(_objectSpread({}, state[action.component] ? state[action.component] : {}), {}, {
      isLoading: action.isLoading
    })));
  }
  return state;
}

export { aiReducer as default };
