function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var ADD_CONFIG = 'ADD_CONFIG';
var UPDATE_CONFIG = 'UPDATE_CONFIG';
var UPDATE_ANALYTICS_CONFIG = 'UPDATE_ANALYTICS_CONFIG';

// defaultAnalytics Config
var defaultAnalyticsConfig = {
  emptyQuery: true,
  suggestionAnalytics: true,
  userId: null,
  customEvents: null,
  enableQueryRules: true
};

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function configReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    analyticsConfig: defaultAnalyticsConfig,
    lock: false
  };
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === ADD_CONFIG) {
    return _objectSpread(_objectSpread({}, state), {}, {
      analyticsConfig: _objectSpread(_objectSpread({}, defaultAnalyticsConfig), action.analyticsConfig)
    });
  } else if (action.type === UPDATE_ANALYTICS_CONFIG) {
    return _objectSpread(_objectSpread({}, state), {}, {
      analyticsConfig: _objectSpread(_objectSpread({}, state.analyticsConfig), action.analyticsConfig)
    });
  } else if (action.type === UPDATE_CONFIG) {
    return _objectSpread(_objectSpread({}, state), action.config);
  }
  return state;
}

export { configReducer as default };
