var RECENT_SEARCHES_SUCCESS = 'RECENT_SEARCHES_SUCCESS';
var RECENT_SEARCHES_ERROR = 'RECENT_SEARCHES_ERROR';

function recentSearchesReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;
  if (action.type === RECENT_SEARCHES_SUCCESS) {
    return {
      error: null,
      data: action.data
    };
  } else if (action.type === RECENT_SEARCHES_ERROR) {
    return {
      error: action.error
    };
  }
  return state;
}

export { recentSearchesReducer as default };
