function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}

function toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : String(i);
}

function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var dayjs_min = {exports: {}};

(function (module, exports) {
  !function (t, e) {
    module.exports = e() ;
  }(commonjsGlobal, function () {

    var t = 1e3,
      e = 6e4,
      n = 36e5,
      r = "millisecond",
      i = "second",
      s = "minute",
      u = "hour",
      a = "day",
      o = "week",
      c = "month",
      f = "quarter",
      h = "year",
      d = "date",
      l = "Invalid Date",
      $ = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/,
      y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,
      M = {
        name: "en",
        weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
        months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
        ordinal: function ordinal(t) {
          var e = ["th", "st", "nd", "rd"],
            n = t % 100;
          return "[" + t + (e[(n - 20) % 10] || e[n] || e[0]) + "]";
        }
      },
      m = function m(t, e, n) {
        var r = String(t);
        return !r || r.length >= e ? t : "" + Array(e + 1 - r.length).join(n) + t;
      },
      v = {
        s: m,
        z: function z(t) {
          var e = -t.utcOffset(),
            n = Math.abs(e),
            r = Math.floor(n / 60),
            i = n % 60;
          return (e <= 0 ? "+" : "-") + m(r, 2, "0") + ":" + m(i, 2, "0");
        },
        m: function t(e, n) {
          if (e.date() < n.date()) return -t(n, e);
          var r = 12 * (n.year() - e.year()) + (n.month() - e.month()),
            i = e.clone().add(r, c),
            s = n - i < 0,
            u = e.clone().add(r + (s ? -1 : 1), c);
          return +(-(r + (n - i) / (s ? i - u : u - i)) || 0);
        },
        a: function a(t) {
          return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
        },
        p: function p(t) {
          return {
            M: c,
            y: h,
            w: o,
            d: a,
            D: d,
            h: u,
            m: s,
            s: i,
            ms: r,
            Q: f
          }[t] || String(t || "").toLowerCase().replace(/s$/, "");
        },
        u: function u(t) {
          return void 0 === t;
        }
      },
      g = "en",
      D = {};
    D[g] = M;
    var p = "$isDayjsObject",
      S = function S(t) {
        return t instanceof _ || !(!t || !t[p]);
      },
      w = function t(e, n, r) {
        var i;
        if (!e) return g;
        if ("string" == typeof e) {
          var s = e.toLowerCase();
          D[s] && (i = s), n && (D[s] = n, i = s);
          var u = e.split("-");
          if (!i && u.length > 1) return t(u[0]);
        } else {
          var a = e.name;
          D[a] = e, i = a;
        }
        return !r && i && (g = i), i || !r && g;
      },
      O = function O(t, e) {
        if (S(t)) return t.clone();
        var n = "object" == _typeof(e) ? e : {};
        return n.date = t, n.args = arguments, new _(n);
      },
      b = v;
    b.l = w, b.i = S, b.w = function (t, e) {
      return O(t, {
        locale: e.$L,
        utc: e.$u,
        x: e.$x,
        $offset: e.$offset
      });
    };
    var _ = function () {
        function M(t) {
          this.$L = w(t.locale, null, !0), this.parse(t), this.$x = this.$x || t.x || {}, this[p] = !0;
        }
        var m = M.prototype;
        return m.parse = function (t) {
          this.$d = function (t) {
            var e = t.date,
              n = t.utc;
            if (null === e) return new Date(NaN);
            if (b.u(e)) return new Date();
            if (e instanceof Date) return new Date(e);
            if ("string" == typeof e && !/Z$/i.test(e)) {
              var r = e.match($);
              if (r) {
                var i = r[2] - 1 || 0,
                  s = (r[7] || "0").substring(0, 3);
                return n ? new Date(Date.UTC(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s)) : new Date(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s);
              }
            }
            return new Date(e);
          }(t), this.init();
        }, m.init = function () {
          var t = this.$d;
          this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
        }, m.$utils = function () {
          return b;
        }, m.isValid = function () {
          return !(this.$d.toString() === l);
        }, m.isSame = function (t, e) {
          var n = O(t);
          return this.startOf(e) <= n && n <= this.endOf(e);
        }, m.isAfter = function (t, e) {
          return O(t) < this.startOf(e);
        }, m.isBefore = function (t, e) {
          return this.endOf(e) < O(t);
        }, m.$g = function (t, e, n) {
          return b.u(t) ? this[e] : this.set(n, t);
        }, m.unix = function () {
          return Math.floor(this.valueOf() / 1e3);
        }, m.valueOf = function () {
          return this.$d.getTime();
        }, m.startOf = function (t, e) {
          var n = this,
            r = !!b.u(e) || e,
            f = b.p(t),
            l = function l(t, e) {
              var i = b.w(n.$u ? Date.UTC(n.$y, e, t) : new Date(n.$y, e, t), n);
              return r ? i : i.endOf(a);
            },
            $ = function $(t, e) {
              return b.w(n.toDate()[t].apply(n.toDate("s"), (r ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e)), n);
            },
            y = this.$W,
            M = this.$M,
            m = this.$D,
            v = "set" + (this.$u ? "UTC" : "");
          switch (f) {
            case h:
              return r ? l(1, 0) : l(31, 11);
            case c:
              return r ? l(1, M) : l(0, M + 1);
            case o:
              var g = this.$locale().weekStart || 0,
                D = (y < g ? y + 7 : y) - g;
              return l(r ? m - D : m + (6 - D), M);
            case a:
            case d:
              return $(v + "Hours", 0);
            case u:
              return $(v + "Minutes", 1);
            case s:
              return $(v + "Seconds", 2);
            case i:
              return $(v + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, m.endOf = function (t) {
          return this.startOf(t, !1);
        }, m.$set = function (t, e) {
          var n,
            o = b.p(t),
            f = "set" + (this.$u ? "UTC" : ""),
            l = (n = {}, n[a] = f + "Date", n[d] = f + "Date", n[c] = f + "Month", n[h] = f + "FullYear", n[u] = f + "Hours", n[s] = f + "Minutes", n[i] = f + "Seconds", n[r] = f + "Milliseconds", n)[o],
            $ = o === a ? this.$D + (e - this.$W) : e;
          if (o === c || o === h) {
            var y = this.clone().set(d, 1);
            y.$d[l]($), y.init(), this.$d = y.set(d, Math.min(this.$D, y.daysInMonth())).$d;
          } else l && this.$d[l]($);
          return this.init(), this;
        }, m.set = function (t, e) {
          return this.clone().$set(t, e);
        }, m.get = function (t) {
          return this[b.p(t)]();
        }, m.add = function (r, f) {
          var d,
            l = this;
          r = Number(r);
          var $ = b.p(f),
            y = function y(t) {
              var e = O(l);
              return b.w(e.date(e.date() + Math.round(t * r)), l);
            };
          if ($ === c) return this.set(c, this.$M + r);
          if ($ === h) return this.set(h, this.$y + r);
          if ($ === a) return y(1);
          if ($ === o) return y(7);
          var M = (d = {}, d[s] = e, d[u] = n, d[i] = t, d)[$] || 1,
            m = this.$d.getTime() + r * M;
          return b.w(m, this);
        }, m.subtract = function (t, e) {
          return this.add(-1 * t, e);
        }, m.format = function (t) {
          var e = this,
            n = this.$locale();
          if (!this.isValid()) return n.invalidDate || l;
          var r = t || "YYYY-MM-DDTHH:mm:ssZ",
            i = b.z(this),
            s = this.$H,
            u = this.$m,
            a = this.$M,
            o = n.weekdays,
            c = n.months,
            f = n.meridiem,
            h = function h(t, n, i, s) {
              return t && (t[n] || t(e, r)) || i[n].slice(0, s);
            },
            d = function d(t) {
              return b.s(s % 12 || 12, t, "0");
            },
            $ = f || function (t, e, n) {
              var r = t < 12 ? "AM" : "PM";
              return n ? r.toLowerCase() : r;
            };
          return r.replace(y, function (t, r) {
            return r || function (t) {
              switch (t) {
                case "YY":
                  return String(e.$y).slice(-2);
                case "YYYY":
                  return b.s(e.$y, 4, "0");
                case "M":
                  return a + 1;
                case "MM":
                  return b.s(a + 1, 2, "0");
                case "MMM":
                  return h(n.monthsShort, a, c, 3);
                case "MMMM":
                  return h(c, a);
                case "D":
                  return e.$D;
                case "DD":
                  return b.s(e.$D, 2, "0");
                case "d":
                  return String(e.$W);
                case "dd":
                  return h(n.weekdaysMin, e.$W, o, 2);
                case "ddd":
                  return h(n.weekdaysShort, e.$W, o, 3);
                case "dddd":
                  return o[e.$W];
                case "H":
                  return String(s);
                case "HH":
                  return b.s(s, 2, "0");
                case "h":
                  return d(1);
                case "hh":
                  return d(2);
                case "a":
                  return $(s, u, !0);
                case "A":
                  return $(s, u, !1);
                case "m":
                  return String(u);
                case "mm":
                  return b.s(u, 2, "0");
                case "s":
                  return String(e.$s);
                case "ss":
                  return b.s(e.$s, 2, "0");
                case "SSS":
                  return b.s(e.$ms, 3, "0");
                case "Z":
                  return i;
              }
              return null;
            }(t) || i.replace(":", "");
          });
        }, m.utcOffset = function () {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, m.diff = function (r, d, l) {
          var $,
            y = this,
            M = b.p(d),
            m = O(r),
            v = (m.utcOffset() - this.utcOffset()) * e,
            g = this - m,
            D = function D() {
              return b.m(y, m);
            };
          switch (M) {
            case h:
              $ = D() / 12;
              break;
            case c:
              $ = D();
              break;
            case f:
              $ = D() / 3;
              break;
            case o:
              $ = (g - v) / 6048e5;
              break;
            case a:
              $ = (g - v) / 864e5;
              break;
            case u:
              $ = g / n;
              break;
            case s:
              $ = g / e;
              break;
            case i:
              $ = g / t;
              break;
            default:
              $ = g;
          }
          return l ? $ : b.a($);
        }, m.daysInMonth = function () {
          return this.endOf(c).$D;
        }, m.$locale = function () {
          return D[this.$L];
        }, m.locale = function (t, e) {
          if (!t) return this.$L;
          var n = this.clone(),
            r = w(t, e, !0);
          return r && (n.$L = r), n;
        }, m.clone = function () {
          return b.w(this.$d, this);
        }, m.toDate = function () {
          return new Date(this.valueOf());
        }, m.toJSON = function () {
          return this.isValid() ? this.toISOString() : null;
        }, m.toISOString = function () {
          return this.$d.toISOString();
        }, m.toString = function () {
          return this.$d.toUTCString();
        }, M;
      }(),
      k = _.prototype;
    return O.prototype = k, [["$ms", r], ["$s", i], ["$m", s], ["$H", u], ["$W", a], ["$M", c], ["$y", h], ["$D", d]].forEach(function (t) {
      k[t[1]] = function (e) {
        return this.$g(e, t[0], t[1]);
      };
    }), O.extend = function (t, e) {
      return t.$i || (t(e, _, O), t.$i = !0), O;
    }, O.locale = w, O.isDayjs = S, O.unix = function (t) {
      return O(1e3 * t);
    }, O.en = D[g], O.Ls = D, O.p = {}, O;
  });
})(dayjs_min);
var dayjs_minExports = dayjs_min.exports;
var dayjs = /*@__PURE__*/getDefaultExportFromCjs(dayjs_minExports);

var componentTypes = {
  reactiveList: 'REACTIVELIST',
  // search components
  dataSearch: 'DATASEARCH',
  categorySearch: 'CATEGORYSEARCH',
  searchBox: 'SEARCHBOX',
  // list components
  singleList: 'SINGLELIST',
  multiList: 'MULTILIST',
  singleDataList: 'SINGLEDATALIST',
  tabDataList: 'TABDATALIST',
  singleDropdownList: 'SINGLEDROPDOWNLIST',
  multiDataList: 'MULTIDATALIST',
  multiDropdownList: 'MULTIDROPDOWNLIST',
  singleDropdownRange: 'SINGLEDROPDOWNRANGE',
  treeList: 'TREELIST',
  // basic components
  numberBox: 'NUMBERBOX',
  tagCloud: 'TAGCLOUD',
  toggleButton: 'TOGGLEBUTTON',
  reactiveComponent: 'REACTIVECOMPONENT',
  // range components
  datePicker: 'DATEPICKER',
  dateRange: 'DATERANGE',
  dynamicRangeSlider: 'DYNAMICRANGESLIDER',
  multiDropdownRange: 'MULTIDROPDOWNRANGE',
  singleRange: 'SINGLERANGE',
  multiRange: 'MULTIRANGE',
  rangeSlider: 'RANGESLIDER',
  ratingsFilter: 'RATINGSFILTER',
  rangeInput: 'RANGEINPUT',
  // map components
  geoDistanceDropdown: 'GEO_DISTANCE_DROPDOWN',
  geoDistanceSlider: 'GEO_DISTANCE_SLIDER',
  reactiveMap: 'REACTIVE_MAP',
  // chart components
  reactiveChart: 'REACTIVE_CHART',
  // ai component
  AIAnswer: 'AI_ANSWER'
};
var queryTypes = {
  search: 'search',
  term: 'term',
  range: 'range',
  geo: 'geo',
  suggestion: 'suggestion'
};

var dateFormats = {
  date: 'YYYY-MM-DD',
  basic_date: 'YYYYMMDD',
  basic_date_time: 'YYYYMMDD[T]HHmmss.SSSZ',
  basic_date_time_no_millis: 'YYYYMMDD[T]HHmmssZ',
  date_time_no_millis: 'YYYY-MM-DD[T]HH:mm:ssZ',
  basic_time: 'HHmmss.SSSZ',
  basic_time_no_millis: 'HHmmssZ',
  epoch_millis: 'epoch_millis',
  epoch_second: 'epoch_second'
};

var _componentTypeToDefau;
function formatDate(date, props) {
  if (props.parseDate) {
    // We would be passing an instance of dayjs instead of xdate below. Users need to know.
    return props.parseDate(date, props);
  }
  switch (props.queryFormat) {
    case 'epoch_millis':
      return date.valueOf();
    case 'epoch_second':
      return Math.floor(date.valueOf() / 1000);
    default:
      {
        if (dateFormats[props.queryFormat]) {
          return date.format(dateFormats[props.queryFormat]);
        }
        return date.valueOf();
      }
  }
}
(_componentTypeToDefau = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleList, ''), componentTypes.multiList, []), componentTypes.singleDataList, ''), componentTypes.singleDropdownList, ''), componentTypes.multiDataList, []), componentTypes.multiDropdownList, []), componentTypes.tagCloud, ''), componentTypes.toggleButton, ''), componentTypes.singleDropdownRange, ''), componentTypes.multiDropdownRange, []), _defineProperty(_defineProperty(_componentTypeToDefau, componentTypes.singleRange, ''), componentTypes.multiRange, []));

/* isValidDateRangeQueryFormat() checks if the queryFormat is one of the dateFormats
	accepted by the elasticsearch or not. */
function isValidDateRangeQueryFormat(queryFormat) {
  return Object.keys(dateFormats).includes(queryFormat);
}

var _componentToTypeMap;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var componentToTypeMap = (_componentToTypeMap = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.reactiveList, queryTypes.search), componentTypes.dataSearch, queryTypes.search), componentTypes.categorySearch, queryTypes.search), componentTypes.searchBox, queryTypes.suggestion), componentTypes.AIAnswer, queryTypes.search), componentTypes.singleList, queryTypes.term), componentTypes.multiList, queryTypes.term), componentTypes.singleDataList, queryTypes.term), componentTypes.singleDropdownList, queryTypes.term), componentTypes.multiDataList, queryTypes.term), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownList, queryTypes.term), componentTypes.tagCloud, queryTypes.term), componentTypes.toggleButton, queryTypes.term), componentTypes.reactiveChart, queryTypes.term), componentTypes.treeList, queryTypes.term), componentTypes.numberBox, queryTypes.term), componentTypes.datePicker, queryTypes.range), componentTypes.dateRange, queryTypes.range), componentTypes.dynamicRangeSlider, queryTypes.range), componentTypes.singleDropdownRange, queryTypes.range), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_componentToTypeMap, componentTypes.multiDropdownRange, queryTypes.range), componentTypes.singleRange, queryTypes.range), componentTypes.multiRange, queryTypes.range), componentTypes.rangeSlider, queryTypes.range), componentTypes.ratingsFilter, queryTypes.range), componentTypes.rangeInput, queryTypes.range), componentTypes.geoDistanceDropdown, queryTypes.geo), componentTypes.geoDistanceSlider, queryTypes.geo), componentTypes.reactiveMap, queryTypes.geo));
var multiRangeComponents = [componentTypes.multiRange, componentTypes.multiDropdownRange];
var dateRangeComponents = [componentTypes.dateRange, componentTypes.datePicker];
var searchComponents = [componentTypes.categorySearch, componentTypes.dataSearch, componentTypes.searchBox];
var listComponentsWithPagination = [componentTypes.singleList, componentTypes.multiList, componentTypes.singleDropdownList, componentTypes.multiDropdownList];
var getNormalizedField = function getNormalizedField(field) {
  if (field && !Array.isArray(field)) {
    return [field];
  }
  return field;
};
var isInternalComponent = function isInternalComponent() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentID.endsWith('__internal');
};
var getInternalComponentID = function getInternalComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__internal");
};
var getHistogramComponentID = function getHistogramComponentID() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(componentID, "__histogram__internal");
};
var isDRSRangeComponent = function isDRSRangeComponent() {
  var componentID = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentID.endsWith('__range__internal');
};
var isSearchComponent = function isSearchComponent() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return searchComponents.includes(componentType);
};
var isComponentUsesLabelAsValue = function isComponentUsesLabelAsValue() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return componentType === componentTypes.multiDataList || componentType === componentTypes.singleDataList || componentType === componentTypes.tabDataList;
};
var hasPaginationSupport = function hasPaginationSupport() {
  var componentType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return listComponentsWithPagination.includes(componentType);
};
var getRSQuery = function getRSQuery(componentId, props) {
  var execute = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  if (props && componentId) {
    var queryType = props.type ? props.type : componentToTypeMap[props.componentType];
    // dataField is a required field for components other than search
    // TODO: Revisit this logic based on the Appbase version
    // dataField is no longer a required field in RS API
    if (props.componentType !== componentTypes.AIAnswer && !isSearchComponent(props.componentType) && !props.dataField && !props.vectorDataField) {
      return null;
    }
    var endpoint;
    var compoundClause = props.compoundClause;
    if (props.endpoint instanceof Object) {
      endpoint = props.endpoint;
    }
    var featuredSuggestionsProps = {
      enableFeaturedSuggestions: props.enableFeaturedSuggestions,
      featuredSuggestionsConfig: props.featuredSuggestionsConfig
    };
    var faqSuggestionsProps = {
      enableFAQSuggestions: props.enableFAQSuggestions,
      FAQSuggestionsConfig: props.FAQSuggestionsConfig
    };
    if (props.enableFAQSuggestions && !props.searchboxId) {
      faqSuggestionsProps = {};
      console.error('Reactivesearch Error: You should also pass a searchboxId when passing enableFAQSuggestions as true.\nRefer to Searchbox component documentation specific to frontend frameworks.\n\nReact(https://docs.reactivesearch.io/docs/reactivesearch/react/search/searchbox/)\n\nVue(https://docs.reactivesearch.io/docs/reactivesearch/vue/search/SearchBox/).');
    }
    if (props.enableFeaturedSuggestions && !props.searchboxId) {
      featuredSuggestionsProps = {};
      console.error('Reactivesearch Error: You should also pass a searchboxId when passing enableFeaturedSuggestions.\nRefer to Searchbox component documentation specific to frontend frameworks.\n\nReact(https://docs.reactivesearch.io/docs/reactivesearch/react/search/searchbox/)\n\nVue(https://docs.reactivesearch.io/docs/reactivesearch/vue/search/SearchBox/).');
    }
    if (compoundClause && !['filter', 'must'].includes(compoundClause)) {
      console.error("Reactivesearch Error: Invalid prop supplied - compoundClause. Prop can be one of ['filter', 'must']");
      compoundClause = undefined;
    }
    return _objectSpread(_objectSpread(_objectSpread({
      id: componentId,
      type: queryType || queryTypes.search,
      dataField: getNormalizedField(props.dataField),
      execute: execute,
      react: props.react,
      highlight: props.highlight,
      highlightField: getNormalizedField(props.highlightField),
      fuzziness: props.fuzziness,
      searchOperators: props.searchOperators,
      includeFields: props.includeFields,
      excludeFields: props.excludeFields,
      size: props.size,
      aggregationSize: props.aggregationSize,
      from: props.from || undefined,
      // Need to maintain for RL
      queryFormat: props.queryFormat,
      sortBy: props.sortBy,
      fieldWeights: getNormalizedField(props.fieldWeights),
      includeNullValues: props.includeNullValues,
      aggregationField: props.aggregationField || undefined,
      categoryField: props.categoryField || undefined,
      missingLabel: props.missingLabel || undefined,
      showMissing: props.showMissing,
      nestedField: props.nestedField || undefined,
      interval: props.interval,
      highlightConfig: props.customHighlight || props.highlightConfig,
      customQuery: props.customQuery,
      defaultQuery: props.defaultQuery,
      value: props.value,
      categoryValue: props.categoryValue || undefined,
      after: props.after || undefined,
      aggregations: props.aggregations || undefined,
      enableSynonyms: props.enableSynonyms,
      selectAllLabel: props.selectAllLabel,
      pagination: props.pagination,
      queryString: props.queryString,
      distinctField: props.distinctField,
      distinctFieldConfig: props.distinctFieldConfig,
      index: props.index,
      compoundClause: compoundClause
    }, queryType === queryTypes.suggestion ? _objectSpread(_objectSpread(_objectSpread({
      enablePopularSuggestions: props.enablePopularSuggestions,
      enableEndpointSuggestions: props.enableEndpointSuggestions,
      enableRecentSuggestions: props.enableRecentSuggestions,
      popularSuggestionsConfig: props.popularSuggestionsConfig,
      recentSuggestionsConfig: props.recentSuggestionsConfig,
      applyStopwords: props.applyStopwords,
      customStopwords: props.customStopwords,
      enablePredictiveSuggestions: props.enablePredictiveSuggestions,
      indexSuggestionsConfig: props.indexSuggestionsConfig,
      enableDocumentSuggestions: props.enableDocumentSuggestions,
      showDistinctSuggestions: props.showDistinctSuggestions,
      documentSuggestionsConfig: props.enableDocumentSuggestions ? props.documentSuggestionsConfig : undefined
    }, featuredSuggestionsProps), faqSuggestionsProps), {}, {
      enableIndexSuggestions: props.enableIndexSuggestions
    }, props.searchboxId ? {
      searchboxId: props.searchboxId
    } : {}) : {}), {}, {
      calendarInterval: props.calendarInterval,
      endpoint: endpoint,
      range: props.range
    }, queryType !== queryTypes.suggestion && props.enableAI && execute ? _objectSpread(_objectSpread({
      enableAI: true
    }, props.AIConfig ? {
      AIConfig: props.AIConfig
    } : {}), {}, {
      execute: true
    }) : {}), queryType !== queryTypes.suggestion ? {
      vectorDataField: props.vectorDataField || undefined,
      imageValue: props.imageValue || undefined,
      candidates: props.candidates || props.size || undefined
    } : {});
  }
  return null;
};
var getValidInterval = function getValidInterval(interval) {
  var range = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var min = Math.ceil((range.end - range.start) / 100) || 1;
  if (!interval) {
    return min;
  } else if (interval < min) {
    return min;
  }
  return interval;
};
var extractPropsFromState = function extractPropsFromState(store, component, customOptions) {
  var componentProps = store.props[component];
  if (!componentProps) {
    return null;
  }
  var queryType = componentProps.type ? componentProps.type : componentToTypeMap[componentProps.componentType];
  var calcValues = store.selectedValues[component];
  var value = calcValues !== undefined && calcValues !== null ? calcValues.value : undefined;
  var queryFormat = componentProps.queryFormat;
  // calendarInterval only supported when using date types
  var calendarInterval;
  var interval = componentProps.interval;
  var type = queryType;
  var dataField = componentProps.dataField;
  var aggregations = componentProps.aggregations;
  var pagination; // pagination for `term` type of queries
  var from = componentProps.from; // offset for RL
  var range; // applicable for range components supporting histogram

  // For term queries i.e list component `dataField` will be treated as aggregationField
  if (queryType === queryTypes.term) {
    // Only apply pagination prop for the components which supports it otherwise it can break the UI
    if (componentProps.showLoadMore && hasPaginationSupport(componentProps.componentType)) {
      pagination = true;
    }
    // Extract values from components that are type of objects
    // This code handles the controlled behavior in list components for e.g ToggleButton
    if (value != null && _typeof(value) === 'object' && value.value) {
      value = value.value;
    } else if (Array.isArray(value)) {
      var parsedValue = [];
      value.forEach(function (val) {
        if (val != null && _typeof(val) === 'object' && val.value) {
          parsedValue.push(val.value);
        } else {
          parsedValue.push(val);
        }
      });
      value = parsedValue;
    }
  }
  if (queryType === queryTypes.range) {
    if (Array.isArray(value)) {
      if (multiRangeComponents.includes(componentProps.componentType)) {
        value = value.map(function (_ref) {
          var start = _ref.start,
            end = _ref.end;
          return {
            start: start,
            end: end
          };
        });
      } else {
        value = {
          start: value[0],
          end: value[1]
        };
      }
    } else if (componentProps.showHistogram) {
      var internalComponentID = getInternalComponentID(component);
      var internalComponentValue = store.internalValues[internalComponentID];
      if (!internalComponentValue) {
        // Handle dynamic range slider
        var histogramComponentID = getHistogramComponentID(component);
        internalComponentValue = store.internalValues[histogramComponentID];
      }
      if (internalComponentValue && Array.isArray(internalComponentValue.value)) {
        value = {
          start: internalComponentValue.value[0],
          end: internalComponentValue.value[1]
        };
      }
    }
    if (isDRSRangeComponent(component)) {
      aggregations = ['min', 'max'];
    } else if (componentProps.showHistogram) {
      aggregations = ['histogram'];
    }

    // handle number box, number box query changes based on the `queryFormat` value
    if (componentProps.componentType === componentTypes.dynamicRangeSlider || componentProps.componentType === componentTypes.rangeSlider) {
      calendarInterval = Object.keys(dateFormats).includes(queryFormat) ? componentProps.calendarInterval : undefined;

      // Set value
      if (value) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          // check if date types are dealt with
          value = {
            start: formatDate(dayjs(new Date(value.start)), componentProps),
            end: formatDate(dayjs(new Date(value.end)), componentProps)
          };
        } else {
          value = {
            start: parseFloat(value.start),
            end: parseFloat(value.end)
          };
        }
      }
      var rangeValue;
      if (componentProps.componentType === componentTypes.dynamicRangeSlider) {
        rangeValue = store.aggregations["".concat(component, "__range__internal")];
        if (componentProps.nestedField) {
          rangeValue = rangeValue && store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].min ? {
            start: store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].min.value,
            end: store.aggregations["".concat(component, "__range__internal")][componentProps.nestedField].max.value
          } // prettier-ignore
          : null;
        } else {
          rangeValue = rangeValue && store.aggregations["".concat(component, "__range__internal")].min && store.aggregations["".concat(component, "__range__internal")].min.value ? {
            start: store.aggregations["".concat(component, "__range__internal")].min.value,
            end: store.aggregations["".concat(component, "__range__internal")].max.value
          } // prettier-ignore
          : null;
        }
      } else {
        rangeValue = componentProps.range;
      }
      if (rangeValue) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          // check if date types are dealt with
          range = {
            start: formatDate(dayjs(rangeValue.start), componentProps),
            end: formatDate(dayjs(rangeValue.end), componentProps)
          };
        } else {
          range = {
            start: parseFloat(rangeValue.start),
            end: parseFloat(rangeValue.end)
          };
        }
      }
    }

    // handle date components
    if (dateRangeComponents.includes(componentProps.componentType)) {
      // Set value
      if (value) {
        if (isValidDateRangeQueryFormat(componentProps.queryFormat)) {
          if (typeof value === 'string') {
            value = {
              // value would be an ISO Date string
              start: formatDate(dayjs(value).subtract(24, 'hour'), componentProps),
              end: formatDate(dayjs(value), componentProps)
            };
          } else if (Array.isArray(value)) {
            value = value.map(function (val) {
              return {
                // value would be one of ISO Date string, number, native date
                start: formatDate(dayjs(val).subtract(24, 'hour'), componentProps),
                end: formatDate(dayjs(val), componentProps)
              };
            });
          } else {
            value = {
              start: formatDate(dayjs(value.start).subtract(24, 'hour'), componentProps),
              end: formatDate(dayjs(value.end), componentProps)
            };
          }
        }
      }
    }
  }
  if (queryType === queryTypes.geo) {
    // override the value extracted from selectedValues reducer
    value = undefined;
    var geoCalcValues = store.selectedValues[component] || store.internalValues[component] || store.internalValues[getInternalComponentID(component)];
    if (geoCalcValues && geoCalcValues.meta) {
      if (geoCalcValues.meta.distance && geoCalcValues.meta.coordinates) {
        value = {
          distance: geoCalcValues.meta.distance,
          location: geoCalcValues.meta.coordinates
        };
        if (componentProps.unit) {
          value.unit = componentProps.unit;
        }
      }
      if (geoCalcValues.meta.mapBoxBounds && geoCalcValues.meta.mapBoxBounds.top_left && geoCalcValues.meta.mapBoxBounds.bottom_right) {
        value = {
          // Note: format will be reverse of what we're using now
          geoBoundingBox: {
            topLeft: "".concat(geoCalcValues.meta.mapBoxBounds.top_left[1], ", ").concat(geoCalcValues.meta.mapBoxBounds.top_left[0]),
            bottomRight: "".concat(geoCalcValues.meta.mapBoxBounds.bottom_right[1], ", ").concat(geoCalcValues.meta.mapBoxBounds.bottom_right[0])
          }
        };
      }
    }
  }
  // handle number box, number box query changes based on the `queryFormat` value
  if (componentProps.componentType === componentTypes.numberBox) {
    if (queryFormat === 'exact') {
      type = 'term';
    } else {
      type = 'range';
      if (queryFormat === 'lte') {
        value = {
          end: value,
          boost: 2.0
        };
      } else {
        value = {
          start: value,
          boost: 2.0
        };
      }
    }
    // Remove query format
    queryFormat = 'or';
  }
  // Fake dataField for ReactiveComponent
  // TODO: Remove it after some time. The `dataField` is no longer required
  if (componentProps.componentType === componentTypes.reactiveComponent) {
    // Set the type to `term`
    type = 'term';
    dataField = 'reactive_component_field';
    // Don't set value property for ReactiveComponent
    // since it is driven by `defaultQuery` and `customQuery`
    value = undefined;
  }
  // Assign default value as an empty string for search components so search relevancy can work
  if (isSearchComponent(componentProps.componentType) && !value) {
    value = '';
  }

  // Handle components which uses label instead of value as the selected value
  if (isComponentUsesLabelAsValue(componentProps.componentType)) {
    var data = componentProps.data,
      selectAllLabel = componentProps.selectAllLabel;
    var absValue = [];
    if (value && Array.isArray(value)) {
      absValue = value;
    } else if (value && typeof value === 'string') {
      absValue = [value];
    }
    var normalizedValue = [];
    if (absValue.length) {
      if (data && Array.isArray(data)) {
        absValue.forEach(function (val) {
          var dataItem = data.find(function (o) {
            return o.label === val;
          });
          if (dataItem && dataItem.value) {
            normalizedValue.push(dataItem.value);
          }
        });
      }
    }
    if (selectAllLabel && absValue.length && absValue.includes(selectAllLabel)) {
      normalizedValue = absValue;
    }
    if (normalizedValue.length) {
      value = normalizedValue;
    } else {
      value = undefined;
    }
  }
  if (componentProps.componentType === componentTypes.reactiveList) {
    // We set selected page as the value in the redux store for RL.
    // It's complex to change this logic in the component so changed it here.
    if (value > 0) {
      from = (value - 1) * (componentProps.size || 10);
    }
    value = undefined;
  }
  var queryValue = value || undefined;
  if (componentProps.componentType === componentTypes.searchBox) {
    if (Array.isArray(queryValue)) {
      queryValue = undefined;
    }
  }
  var endpoint;
  if (componentProps.endpoint instanceof Object) {
    endpoint = _objectSpread(_objectSpread({}, endpoint || {}), componentProps.endpoint);
  }
  return _objectSpread(_objectSpread({}, componentProps), {}, {
    endpoint: endpoint,
    calendarInterval: calendarInterval,
    dataField: dataField,
    queryFormat: queryFormat,
    type: type,
    aggregations: aggregations,
    interval: interval,
    react: store.dependencyTree ? store.dependencyTree[component] : undefined,
    customQuery: store.customQueries ? store.customQueries[component] : undefined,
    defaultQuery: store.defaultQueries ? store.defaultQueries[component] : undefined,
    customHighlight: store.customHighlightOptions ? store.customHighlightOptions[component] : undefined,
    categoryValue: store.internalValues[component] ? store.internalValues[component].category : undefined,
    value: queryValue,
    pagination: pagination,
    from: from,
    range: range
  }, customOptions);
};
function flatReactProp(reactProp, componentID) {
  var flattenReact = [];
  var flatReact = function flatReact(react) {
    if (react && Object.keys(react)) {
      Object.keys(react).forEach(function (r) {
        if (react[r]) {
          if (typeof react[r] === 'string') {
            flattenReact = [].concat(_toConsumableArray(flattenReact), [react[r]]);
          } else if (Array.isArray(react[r])) {
            flattenReact = [].concat(_toConsumableArray(flattenReact), _toConsumableArray(react[r]));
          } else if (_typeof(react[r]) === 'object') {
            flatReact(react[r]);
          }
        }
      });
    }
  };
  flatReact(reactProp);
  // Remove cyclic dependencies
  flattenReact = flattenReact.filter(function (react) {
    return react !== componentID;
  });
  return flattenReact;
}
var getDependentQueries = function getDependentQueries(store, componentID) {
  var orderOfQueries = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var finalQuery = {};
  var react = flatReactProp(store.dependencyTree[componentID], componentID);
  react.forEach(function (componentObject) {
    var component = componentObject;
    var customQuery = store.customQueries[component];
    if (!isInternalComponent(component)) {
      var calcValues = store.selectedValues[component] || store.internalValues[component];
      var imageValue = calcValues && calcValues.meta && calcValues.meta.imageValue;
      // Only include queries for that component that has `customQuery` or `value` or
      // `imageValue` incase of searchbox defined
      if ((calcValues && (calcValues.value || imageValue) || customQuery) && !finalQuery[component]) {
        var execute = false;
        var componentProps = store.props[component];
        if (Array.isArray(orderOfQueries) && orderOfQueries.includes(component) && !(componentProps.componentType === componentTypes.searchBox
        /**
         * We want to fire a search query,
         * 	when enableAI
         * 	OR
         * 	when autosuggest is false
         */ && (componentProps.enableAI || componentProps.autosuggest === false))) {
          execute = true;
        }
        // build query
        var dependentQuery = getRSQuery(component, extractPropsFromState(store, component, _objectSpread({}, componentProps && _objectSpread(_objectSpread({}, componentProps.componentType === componentTypes.searchBox ? _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, execute === false ? {
          type: queryTypes.search
        } : {}), calcValues.category ? {
          categoryValue: calcValues.category
        } : {
          categoryValue: undefined
        }), calcValues.value ? {
          value: calcValues.value
        } : {}), imageValue ? {
          imageValue: imageValue
        } : {}) : {}), componentProps.componentType === componentTypes.categorySearch ? _objectSpread({}, calcValues.category ? {
          categoryValue: calcValues.category
        } : {
          categoryValue: undefined
        }) : {}))), execute);
        if (dependentQuery) {
          finalQuery[component] = dependentQuery;
        }
      }
    }
  });
  return finalQuery;
};
var transformValueToComponentStateFormat = function transformValueToComponentStateFormat(value, componentProps) {
  var componentType = componentProps.componentType,
    data = componentProps.data,
    queryFormat = componentProps.queryFormat;
  var transformedValue = value;
  var meta = {};
  if (value) {
    switch (componentType) {
      case componentTypes.singleDataList:
      case componentTypes.tabDataList:
        transformedValue = '';
        if (Array.isArray(value) && typeof value[0] === 'string') {
          transformedValue = value[0];
        } else if (_typeof(value) === 'object' && value.label) {
          transformedValue = value.label;
        } else {
          transformedValue = value;
        }
        break;
      case componentTypes.multiDataList:
        transformedValue = [];
        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && (valObj.label || valObj.value)) {
              transformedValue.push(valObj.label || valObj.value);
            } else if (typeof valObj === 'string') {
              transformedValue.push(valObj);
            }
          });
        }
        break;
      case componentTypes.toggleButton:
        transformedValue = []; // array of objects

        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && valObj.label && valObj.value) {
              transformedValue.push(valObj);
            } else if (typeof valObj === 'string') {
              var findDataObj = data.find(function (item) {
                return item.label.trim() === valObj.trim() || item.value.trim() === valObj.trim();
              });
              transformedValue.push(findDataObj);
            }
          });
        } else if (_typeof(value) === 'object' && value.label && value.value) {
          transformedValue = value.value;
        } else if (typeof value === 'string') {
          var findDataObj = data.find(function (item) {
            return item.label.trim() === value.trim() || item.value.trim() === value.trim();
          });
          transformedValue = findDataObj.value;
        }
        break;
      case componentTypes.singleRange:
      case componentTypes.singleDropdownRange:
        transformedValue = {};
        if (!Array.isArray(value) && _typeof(value) === 'object') {
          transformedValue = _objectSpread({}, value);
        } else if (typeof value === 'string') {
          var _findDataObj = data.find(function (item) {
            return item.label.trim() === value.trim();
          });
          transformedValue = _objectSpread({}, _findDataObj);
        }
        break;
      case componentTypes.multiDropdownRange:
      case componentTypes.multiRange:
        transformedValue = []; // array of objects

        if (Array.isArray(value)) {
          value.forEach(function (valObj) {
            if (_typeof(valObj) === 'object' && typeof valObj.start === 'number' && typeof valObj.end === 'number') {
              var _findDataObj2 = _objectSpread({}, valObj);
              if (!_findDataObj2.label) {
                _findDataObj2 = data.find(function (item) {
                  return item.start === valObj.start && item.end === valObj.end;
                });
              }
              transformedValue.push(_findDataObj2);
            } else if (typeof valObj === 'string') {
              var _findDataObj3 = data.find(function (item) {
                return item.label.trim() === valObj.trim();
              });
              transformedValue.push(_findDataObj3);
            }
          });
        } else if (typeof value === 'string') {
          var _findDataObj4 = data.find(function (item) {
            return item.label.trim() === value.trim();
          });
          transformedValue.push(_findDataObj4);
        }
        break;
      case componentTypes.rangeSlider:
      case componentTypes.ratingsFilter:
      case componentTypes.dynamicRangeSlider:
      case componentTypes.reactiveChart:
        transformedValue = [];
        if (queryFormat) {
          if (Array.isArray(value)) {
            transformedValue = value.map(function (item) {
              return formatDate(dayjs(item), componentProps);
            });
          } else if (_typeof(value) === 'object') {
            transformedValue = [formatDate(dayjs(value.start), componentProps), formatDate(dayjs(value.end), componentProps)];
          }
        } else if (Array.isArray(value)) {
          transformedValue = _toConsumableArray(value);
        } else if (_typeof(value) === 'object') {
          transformedValue = [value.start, value.end];
        } else {
          transformedValue = value;
        }
        break;
      case componentTypes.numberBox:
        transformedValue = [];
        if (!Array.isArray(value) && _typeof(value) === 'object') {
          transformedValue = value.start;
        } else if (typeof value === 'number') {
          transformedValue = value;
        }
        break;
      case componentTypes.datePicker:
        transformedValue = '';
        if (_typeof(value) !== 'object') {
          transformedValue = dayjs(value).format('YYYY-MM-DD');
        } else if (value.end) {
          transformedValue = dayjs(value.end).format('YYYY-MM-DD');
        } else if (value.start) {
          transformedValue = dayjs(value.start).add(24, 'hour').format('YYYY-MM-DD');
        }
        break;
      case componentTypes.dateRange:
        transformedValue = []; // array of strings
        if (Array.isArray(value)) {
          transformedValue = value.map(function (t) {
            return dayjs(t).format('YYYY-MM-DD');
          });
        } else if (_typeof(value) === 'object') {
          transformedValue = [dayjs(value.start).format('YYYY-MM-DD'), dayjs(value.end).format('YYYY-MM-DD')];
        }
        break;
      case componentTypes.categorySearch:
        transformedValue = '';
        if (_typeof(value) === 'object') {
          transformedValue = value.value;
          if (value.category !== undefined) {
            meta.category = value.category;
          }
        } else if (typeof value === 'string') {
          transformedValue = value;
        }
        break;
    }
  }
  return {
    value: transformedValue,
    meta: meta
  };
};

export { componentToTypeMap, extractPropsFromState, flatReactProp, getDependentQueries, getHistogramComponentID, getInternalComponentID, getNormalizedField, getRSQuery, getValidInterval, hasPaginationSupport, isComponentUsesLabelAsValue, isDRSRangeComponent, isInternalComponent, isSearchComponent, transformValueToComponentStateFormat };
